﻿using System;

namespace ET
{
    public class C2M_RemoveBuildingHandler : AMActorLocationRpcHandler<Unit, C2M_RemoveBuilding, M2C_RemoveBuilding>
    {
        protected async override ETTask Run(Unit unit, C2M_RemoveBuilding request, M2C_RemoveBuilding response, Action reply)
        {
            try
            {
                BuildingComponent buildingComponent = unit.GetComponent<BuildingComponent>();
                buildingComponent.RemoveChildWithId(request.Id);
                
                response.Error = ErrorCode.ERR_Success;
                response.Id = request.Id;
                reply();
            }
            catch (Exception e)
            {
                response.Message = e.ToString();
                response.Error = ErrorCode.ERR_BuildError;
                reply();
            }

            await ETTask.CompletedTask;
        }
    }
}