﻿using System;

namespace ET
{
    [FriendClass(typeof (Farmland))]
    [FriendClass(typeof (Cabin))]
    public class C2M_CabinSeedHandler: AMActorLocationRpcHandler<Unit, C2M_CabinSeed, M2C_CabinSeed>
    {
        protected async override ETTask Run(Unit unit, C2M_CabinSeed request, M2C_CabinSeed res, Action reply)
        {
            try
            {
                res.Error = ErrorCode.ERR_Success;
                var farmland = unit.GetGrandChild<Farmland>(request.FarmlandId);
                if (GameUtil.IsErrorSuc(res.Error) && farmland == null)
                {
                    res.Error = ErrorCode.ERR_PeopleNotFound;
                }

                if (GameUtil.IsErrorSuc(res.Error) && farmland.FarmlandState != FarmlandState.FARMLAND_STATE_FREE)
                {
                    res.Error = ErrorCode.ERR_FarmlandNotFree;
                }
                var cabin = unit.GetGrandChild<Cabin>(farmland.CabinId);
                if (GameUtil.IsErrorSuc(res.Error) && cabin == null)
                {
                    res.Error = ErrorCode.ERR_CabinNotFound;
                }

                if (GameUtil.IsErrorSuc(res.Error) && cabin.ResidentState == 0)
                {
                    res.Error = ErrorCode.ERR_CabinNotPeople;
                }

                if (GameUtil.IsErrorSuc(res.Error) && farmland.FarmlandState != FarmlandState.FARMLAND_STATE_FREE)
                {
                    res.Error = ErrorCode.ERR_FarmlandNotFree;
                }

                if (GameUtil.IsErrorSuc(res.Error))
                {
                    res.Error = CabinOperate.CabinSeed(unit, farmland, request.CropCfgId);
                }

                reply();
            }
            catch (Exception e)
            {
                res.Message = e.ToString();
                res.Error = ErrorCode.ERR_OperateFail;
                reply();
            }

            await ETTask.CompletedTask;
        }
    }
}