﻿using System;

namespace ET
{
   
    
    public class C2M_CabinUpdateFarmlandsHandler: AMActorLocationRpcHandler<Unit, C2M_CabinUpdateFarmlands, M2C_CabinUpdateFarmlands>
    {
        protected async override ETTask Run(Unit unit, C2M_CabinUpdateFarmlands request, M2C_CabinUpdateFarmlands response, Action reply)
        {
            try
            {
                var cabin = unit.GetGrandChild<Cabin>(request.CabinId);
                if (cabin == null)
                {
                    response.Error = ErrorCode.ERR_CabinNotFound;
                }
                else
                {
                    CabinOperate.CabinUpdateFarmlands(unit,cabin,request.FarmlandIds);
                    response.Error = ErrorCode.ERR_Success;
                }

                reply();
            }
            catch (Exception e)
            {
                response.Message = e.ToString();
                response.Error = ErrorCode.ERR_OperateFail;
                reply();
            }

            await ETTask.CompletedTask;
        }
    }
}