﻿using System;

namespace ET
{
    public class C2M_DevelopRecipeHandler: AMActorLocationRpcHandler<Unit, C2M_DevelopRecipe, M2C_DevelopRecipe>
    {
        protected override async ETTask Run(Unit unit, C2M_DevelopRecipe request, M2C_DevelopRecipe response, Action reply)
        {
            
            try
            {
                (response.Error, response.Id) = CuisineOperate.DevelopRecipes(unit, request.Ids);
                reply();
            }
            catch (Exception e)
            {
                Log.Error(e.ToString());
                response.Message = e.ToString();
                response.Error = ErrorCode.ERR_OperateFail;
                reply();
            }

            await ETTask.CompletedTask;
        }
    }
}