﻿using System;

namespace ET
{
    [ActorMessageHandler]
    public class C2M_StartGatherResourceHandler: AMActorLocationRpcHandler<Unit, C2M_StartGatherResource, M2C_StartGatherResource>
    {
        protected async override ETTask Run(Unit unit, C2M_StartGatherResource request, M2C_StartGatherResource response, Action reply)
        {
            try
            {
                response.Error=GatherOperate.StartGather(unit, request.GatherId, request.PeopleId);
                reply();
            }
            catch (Exception e)
            {
                response.Error = ErrorCode.ERR_BuildError;
                response.Message = e.Message;
                reply();
            }
            await ETTask.CompletedTask;
        }
    }
}