﻿using System.Collections.Generic;

namespace ET
{
    public static class SynthesisHelper
    {
        public static void NotifySynthesisUpdate(Unit unit, SynthesisComponent sc)
        {
            var msg = new M2C_NotifySynthesisUpdate();

            MessageHelper.SendToClient(unit, msg);
        }

        public static void NotifySynthesisSection(Unit unit, List<int> configIds)
        {
            var msg = new M2C_NotifySynthesisWithState();
            msg.ConfigIds = configIds;
            msg.State = (int) SynthesisState.Working;

            MessageHelper.SendToClient(unit, msg);
        }

        public static void NotifySynthesisFinish(Unit unit, List<int> configIds)
        {
            var msg = new M2C_NotifySynthesisWithState();
            msg.ConfigIds = configIds;
            msg.State = (int) SynthesisState.Finished;

            MessageHelper.SendToClient(unit, msg);
        }

        public static void NotifySynthesisStop(Unit unit, List<int> configIds)
        {
            var msg = new M2C_NotifySynthesisWithState();
            msg.ConfigIds = configIds;
            msg.State = (int) SynthesisState.Stop; // 1: 部分结束， 2：停止制作， 3：全部结束

            MessageHelper.SendToClient(unit, msg);
        }
    }
}