﻿using System;

namespace ET
{
    
    [ActorMessageHandler]
    public class C2M_GetStoreHandler: AMActorLocationRpcHandler<Unit, C2M_GetStore, M2C_GetStore>
    {
        protected async override ETTask Run(Unit unit, C2M_GetStore request, M2C_GetStore response, Action reply)
        {
            try
            {
                var store = unit.GetComponent<StoreComponent>();
                foreach (var v in store.Children.Values)
                {
                    response.Store.Add(((Item)v).ToMessage());
                }
                response.Error = ErrorCode.ERR_Success;
                reply();
            }
            catch (Exception e)
            {
                response.Message = e.ToString();
                response.Error = ErrorCode.ERR_GetStoreFail;
                reply();
            }

            await ETTask.CompletedTask;

        }
    }
}