﻿using System;

namespace ET.Handler
{
    public class C2M_RootOutResourceHandler : AMActorLocationRpcHandler<Unit, C2M_RootOutResource, M2C_RootOutResource>
    {
        protected override async ETTask Run(Unit unit, C2M_RootOutResource request, M2C_RootOutResource response, Action reply)
        {
            try
            {
                ResourceOperate.RootOutResource(unit, request.ResourceId);

                response.Error = ErrorCode.ERR_Success;
                reply();
            }
            catch (Exception e)
            {
                response.Message = e.ToString();
                response.Error = ErrorCode.ERR_RootOutResourceError;
                reply();
            }

            await ETTask.CompletedTask;
        }
    }
}