﻿using System;

namespace ET
{
    public class C2M_EndSythesisHandler: AMActorLocationRpcHandler<Unit, C2M_EndSynthesis, M2C_EndSynthesis>
    {
        protected override async ETTask Run(Unit unit, C2M_EndSynthesis request, M2C_EndSynthesis response, Action reply)
        {
            try
            {
               var err = SynthesisOperate.EndSynthesis(unit, request.ConfigId);

                response.Error = err;
                reply();
            }
            catch (Exception e)
            {
                response.Message = e.ToString();
                response.Error = ErrorCode.ERR_GetStoreFail;
                reply();
            }

            await ETTask.CompletedTask;
        }
    }
}