using System;
using System.Collections.Generic;

namespace PVSkill
{
    public class SkillBuffConfigCategory : IConfigCategory
    {
        public static SkillBuffConfigCategory Instance;
        public List<SkillBuffConfig> list = new List<SkillBuffConfig>();
        private Dictionary<int, SkillBuffConfig> dict = new Dictionary<int, SkillBuffConfig>();
        
        public SkillBuffConfigCategory()
        {
            Instance = this;
        }
        
        public void Init()
        {
            foreach (SkillBuffConfig config in list)
            {
                this.dict.Add(config.Id, config);
            } 
        }
        
        public SkillBuffConfig Get(int id)
        {
            this.dict.TryGetValue(id, out SkillBuffConfig item);

            if (item == null)
            {
                throw new Exception($"配置找不到，配置表名: {nameof (SkillBuffConfig)}，配置id: {id}");
            }

            return item;
        }
    }


    public class SkillBuffConfig
    {
        public int Id
        {
            get
            {
                return _id;
            }
        }
		public int _id; 
		public string Name { get; set; }
		public int TriggerEvent { get; set; }
		public int TriggerParameter { get; set; }
		public int ObjectType { get; set; }
		public int ScopeType { get; set; }
		public int CDType { get; set; }
		public int CDParameter { get; set; }
		public int Gain { get; set; }
		public int Disperse { get; set; }
		public int ContinuedType { get; set; }
		public int ContinuedParameter { get; set; }
		public int BuffProbability { get; set; }
		public int[] LinkEffect { get; set; }
		public int[] StartTrigger { get; set; }
		public int EndTrigger { get; set; }
		public int Overlay { get; set; }
		public int OverlayMax { get; set; }
		public string Icon { get; set; }
		public int BattleShow { get; set; }
		public string Describe { get; set; }
  
    }
}