using System;
using System.Collections.Generic;

namespace PVSkill
{
    public class SkillConfigCategory : IConfigCategory
    {
        public static SkillConfigCategory Instance;
        public List<SkillConfig> list = new List<SkillConfig>();
        private Dictionary<int, SkillConfig> dict = new Dictionary<int, SkillConfig>();
        
        public SkillConfigCategory()
        {
            Instance = this;
        }
        
        public void Init()
        {
            foreach (SkillConfig config in list)
            {
                this.dict.Add(config.Id, config);
            } 
        }
        
        public SkillConfig Get(int id)
        {
            this.dict.TryGetValue(id, out SkillConfig item);

            if (item == null)
            {
                throw new Exception($"配置找不到，配置表名: {nameof (SkillConfig)}，配置id: {id}");
            }

            return item;
        }
    }


    public class SkillConfig
    {
        public int Id
        {
            get
            {
                return _id;
            }
        }
		public int _id; 
		public string Name { get; set; }
		public int Type { get; set; }
		public int LevelCap { get; set; }
		public int UnlockOne { get; set; }
		public int EffectOne { get; set; }
		public int PassiveEffectOne { get; set; }
		public int UnlockTwo { get; set; }
		public int EffectTwo { get; set; }
		public int PassiveEffectTwo { get; set; }
		public int UnlockThree { get; set; }
		public int EffectThree { get; set; }
		public int PassiveEffectThree { get; set; }
		public int UnlockFour { get; set; }
		public int EffectFour { get; set; }
		public int PassiveEffectFour { get; set; }
		public int UnlockFive { get; set; }
		public int EffectFive { get; set; }
		public int PassiveEffectFive { get; set; }
		public int UnlockSix { get; set; }
		public int EffectSix { get; set; }
		public int PassiveEffectSix { get; set; }
		public int UnlockSeven { get; set; }
		public int EffectSeven { get; set; }
		public int PassiveEffectSeven { get; set; }
		public int UnlockEight { get; set; }
		public int EffectEight { get; set; }
		public int PassiveEffectEight { get; set; }
		public int UnlockNine { get; set; }
		public int EffectNine { get; set; }
		public int PassiveEffectNine { get; set; }
		public int UnlockTen { get; set; }
		public int EffectTen { get; set; }
		public int PassiveEffectTen { get; set; }
		public string Action { get; set; }
		public string Icon { get; set; }
		public string Describe { get; set; }
  
    }
}