using System;
using System.Collections.Generic;

namespace PVSkill
{
    public class SkillEffectConfigCategory : IConfigCategory
    {
        public static SkillEffectConfigCategory Instance;
        public List<SkillEffectConfig> list = new List<SkillEffectConfig>();
        private Dictionary<int, SkillEffectConfig> dict = new Dictionary<int, SkillEffectConfig>();
        
        public SkillEffectConfigCategory()
        {
            Instance = this;
        }
        
        public void Init()
        {
            foreach (SkillEffectConfig config in list)
            {
                this.dict.Add(config.Id, config);
            } 
        }
        
        public SkillEffectConfig Get(int id)
        {
            this.dict.TryGetValue(id, out SkillEffectConfig item);

            if (item == null)
            {
                throw new Exception($"配置找不到，配置表名: {nameof (SkillEffectConfig)}，配置id: {id}");
            }

            return item;
        }
    }


    public class SkillEffectConfig
    {
        public int Id
        {
            get
            {
                return _id;
            }
        }
		public int _id; 
		public int EffectConfig { get; set; }
		public string Bullet { get; set; }
		public string NumericExpression { get; set; }
  
    }
}