using System;
using System.Collections.Generic;

namespace PVSkill
{
    public class SkillFatherConfigCategory : IConfigCategory
    {
        public static SkillFatherConfigCategory Instance;
        public List<SkillFatherConfig> list = new List<SkillFatherConfig>();
        private Dictionary<int, SkillFatherConfig> dict = new Dictionary<int, SkillFatherConfig>();
        
        public SkillFatherConfigCategory()
        {
            Instance = this;
        }
        
        public void Init()
        {
            foreach (SkillFatherConfig config in list)
            {
                this.dict.Add(config.Id, config);
            } 
        }
        
        public SkillFatherConfig Get(int id)
        {
            this.dict.TryGetValue(id, out SkillFatherConfig item);

            if (item == null)
            {
                throw new Exception($"配置找不到，配置表名: {nameof (SkillFatherConfig)}，配置id: {id}");
            }

            return item;
        }
    }


    public class SkillFatherConfig
    {
        public int Id
        {
            get
            {
                return _id;
            }
        }
		public int _id; 
		public string SkillName { get; set; }
		public int Weapon { get; set; }
		public int LearningLevel { get; set; }
		public int Type { get; set; }
		public int SkillType { get; set; }
		public int ActionType { get; set; }
		public int Silence { get; set; }
		public int GetClose { get; set; }
		public int CDType { get; set; }
		public int CDParameter { get; set; }
		public int LevelCap { get; set; }
		public int FightingSpiritConsume { get; set; }
		public int Attribute1 { get; set; }
		public string Attribute1Parameter { get; set; }
		public int Attribute2 { get; set; }
		public string Attribute2Parameter { get; set; }
		public int[] SkillSonGroup { get; set; }
		public int SkillUp { get; set; }
		public string Icon { get; set; }
		public string Describe { get; set; }
  
    }
}