using System;
using System.Collections.Generic;

namespace PVSkill
{
    public class SkillSonConfigCategory : IConfigCategory
    {
        public static SkillSonConfigCategory Instance;
        public List<SkillSonConfig> list = new List<SkillSonConfig>();
        private Dictionary<int, SkillSonConfig> dict = new Dictionary<int, SkillSonConfig>();
        
        public SkillSonConfigCategory()
        {
            Instance = this;
        }
        
        public void Init()
        {
            foreach (SkillSonConfig config in list)
            {
                this.dict.Add(config.Id, config);
            } 
        }
        
        public SkillSonConfig Get(int id)
        {
            this.dict.TryGetValue(id, out SkillSonConfig item);

            if (item == null)
            {
                throw new Exception($"配置找不到，配置表名: {nameof (SkillSonConfig)}，配置id: {id}");
            }

            return item;
        }
    }


    public class SkillSonConfig
    {
        public int Id
        {
            get
            {
                return _id;
            }
        }
		public int _id; 
		public string Name { get; set; }
		public int ActionType { get; set; }
		public int ObjectType { get; set; }
		public int ScopeType { get; set; }
		public int CastPosition { get; set; }
		public int WhetherToCrit { get; set; }
		public int CanBeChase { get; set; }
		public int CanBeParry { get; set; }
		public int CanBeFightBack { get; set; }
		public int CanBeInterrupt { get; set; }
		public int CanBeSupport { get; set; }
		public int DirectInjury { get; set; }
		public int TriggerType { get; set; }
		public int TriggerParameter { get; set; }
		public int[] Buff { get; set; }
		public int[] SkillSon { get; set; }
		public int Unlock { get; set; }
		public string Action { get; set; }
		public string Sound { get; set; }
		public string Icon { get; set; }
		public string Describe { get; set; }
  
    }
}