using System;
using System.Collections.Generic;

namespace PVSkill
{
    public class SkillUpConfigCategory : IConfigCategory
    {
        public static SkillUpConfigCategory Instance;
        public List<SkillUpConfig> list = new List<SkillUpConfig>();
        private Dictionary<int, SkillUpConfig> dict = new Dictionary<int, SkillUpConfig>();
        
        public SkillUpConfigCategory()
        {
            Instance = this;
        }
        
        public void Init()
        {
            foreach (SkillUpConfig config in list)
            {
                this.dict.Add(config.Id, config);
            } 
        }
        
        public SkillUpConfig Get(int id)
        {
            this.dict.TryGetValue(id, out SkillUpConfig item);

            if (item == null)
            {
                throw new Exception($"配置找不到，配置表名: {nameof (SkillUpConfig)}，配置id: {id}");
            }

            return item;
        }
    }


    public class SkillUpConfig
    {
        public int Id
        {
            get
            {
                return _id;
            }
        }
		public int _id; 
		public int SkillId { get; set; }
		public int[] Level1UnlockParameter { get; set; }
		public int[] Level2UnlockParameter { get; set; }
		public int[] Level3UnlockParameter { get; set; }
		public int[] Level4UnlockParameter { get; set; }
		public int[] Level5UnlockParameter { get; set; }
		public int[] Level6UnlockParameter { get; set; }
		public int[] Level7UnlockParameter { get; set; }
		public int[] Level8UnlockParameter { get; set; }
		public int[] Level9UnlockParameter { get; set; }
		public int[] Level10UnlockParameter { get; set; }
  
    }
}