using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.IO;

namespace YooAsset.Editor
{
    public class ExtAsPrefix : IAddressRule
    {
        public string GetAssetAddress(AddressRuleData data)
        {
            string ext = Path.GetExtension(data.AssetPath).Substring(1);
            string noExt = Path.GetFileNameWithoutExtension(data.AssetPath);
            if (!string.IsNullOrEmpty(ext))
            {
                ext = char.ToUpper(ext[0]) + ext.Substring(1);
            }

            return ext + "_" + noExt;
        }
    }
}

