using System.Collections;
using System.Collections.Generic;
using FUICheckUpdate;
using ET;
using FairyGUI;
using UnityEngine;
using YooAsset;

public class FUICheckUpdateComponent
{
    private static FUI_CheckUpdate _checkUpdate;
    private static bool _isInited;
    public static void Init()
    {
        UIPackage.AddPackage($"FUI/{FUI_CheckUpdate.UIPackageName}");
        
        FUI_CheckUpdateBinder.BindAll();
        
        _checkUpdate = FUI_CheckUpdate.CreateInstance();
        _checkUpdate.MakeFullScreen();

        _checkUpdate.DownloadSize.text = "";
        _checkUpdate.DownloadProgress.max = 100;
        _checkUpdate.DownloadProgress.value = 0;
        
        FUIManager_Mono.AddUI(FUI_CheckUpdate.UIResName, _checkUpdate);
        
        SetMessage("");
        
        YooAssetWrapper.OnDownloadProgress = OnDownloadProgress;

        _isInited = true;
    }

    private static void OnDownloadProgress(int totalDownloadCount, int currentDownloadCount, long totalDownloadBytes, long currentDownloadBytes)
    {
        string currentSizeMB = (currentDownloadBytes / 1048576f).ToString("f1");
        string totalSizeMB = (totalDownloadBytes/ 1048576f).ToString("f1");
        string text =
                $"{currentSizeMB}MB/{totalSizeMB}MB";
        _checkUpdate.DownloadSize.text = text;
        _checkUpdate.DownloadProgress.value = (float)currentDownloadBytes / totalDownloadBytes * 100;
    }

    public static void SetMessage(string msg)
    {
        _checkUpdate.Message.text = msg;
    }

    public static void RemoveUI()
    {
        if (_isInited)
        {
            FUIManager_Mono.RemoveUI(FUI_CheckUpdate.UIResName);
            UIPackage.RemovePackage(FUI_CheckUpdate.UIPackageName);         
        }
    }
}
