﻿using System.Collections.Generic;
using ET.EventType;
using UnityEngine;

namespace ET
{
    [FriendClass(typeof(Unit))]
    public class M2C_NotifyNightEventHandler: AMHandler<M2C_NotifyNightEvent>
    {
        protected override void Run(Session session, M2C_NotifyNightEvent message)
        {
            if (message.EventSeed > 0)
            {
                Unit unit = UnitComponent.unit;
                unit.EventSeed = message.EventSeed;
                unit.EventNames = message.EventNames;
                List<NightEvent> nightEvents = UnitOperate.NightEvent(unit, message.NightTime, message.Time);
                Game.EventSystem.Publish(new EventType.ShowNightEvent() { Unit = unit, Events = nightEvents, ShowAni = true});
            }
        }
    }
}