﻿using Animancer;
using UnityEngine;

namespace ET
{
    public class BattleAction_PlayAnimationAwakeSystem: AwakeSystem<BattleAction_PlayAnimation>
    {
        public override void Awake(BattleAction_PlayAnimation self)
        {
            self.Awake();
        }
    }
    
    public class BattleAction_PlayAnimationDestroySystem: DestroySystem<BattleAction_PlayAnimation>
    {
        public override void Destroy(BattleAction_PlayAnimation self)
        {
            self.Destroy();
        }
    }

    [FriendClass(typeof(BattleActionSegment))]
    [FriendClass(typeof(BattleAction_PlayAnimation))]
    public static class BattleAction_PlayAnimationSystem
    {
        public static void Awake(this BattleAction_PlayAnimation self)
        {
        }
        
        public static void AddAnimation(this BattleAction_PlayAnimation self, Animancer.AnimancerState state)
        {
            self.Animations.Add(state);
        }

        public static float GetMaxTime(this BattleAction_PlayAnimation self)
        {
            float time = 0;
            foreach (AnimancerState animancerState in self.Animations)
            {
                if (animancerState.Duration > time)
                {
                    time = animancerState.Duration;
                }
            }

            return time;
        }

        public static void Destroy(this BattleAction_PlayAnimation self)
        {
            foreach (AnimancerState animancerState in self.Animations)
            {
                animancerState.Stop();
            }
            
            self.Animations.Clear();
        }
    }
}
