/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIBuilding;
    public class FUIBuildingInfoWindowComponentAwakeSystem : AwakeSystem<FUIBuildingInfoWindowComponent>
    {
        public override void Awake(FUIBuildingInfoWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(Building))]
    public static partial class FUIBuildingInfoWindowComponentSystem
    {
        public static void Awake(this FUIBuildingInfoWindowComponent self)
        {
            self.FUIBuildingInfoWindow = self.Parent.GetComponent<FUI_BuildingInfoWindow>();      
            self.Window = new Window();
            self.Window.contentPane = self.FUIBuildingInfoWindow.FGComp;
            
            self.FUIBuildingInfoWindow.m_RemoveBuildingButton.FGComp.onClick.Add(self.OnRemoveBuildingButtonClick);
            self.FUIBuildingInfoWindow.m_FixButton.FGComp.onClick.Add(self.OnRepairButtonClick);
            self.FUIBuildingInfoWindow.m_LevelUpButton.FGComp.onClick.Add(self.OnLevelupButtonClick);
        }

        public static void ShowInfo(this FUIBuildingInfoWindowComponent self, Building buildingInfo)
        {
            self.CurEditBuildingInfo = buildingInfo;
            var buildingConfig = StructureConfigCategory.Instance.Get(buildingInfo.ConfigId);
            self.FUIBuildingInfoWindow.m_BuildingName.text = buildingConfig.Name;
            string iconUrl = $"{buildingConfig.Picture}";
            self.FUIBuildingInfoWindow.m_BuildingIcon.url = iconUrl;
            self.FUIBuildingInfoWindow.m_AllowLivingNumber.text = buildingConfig.DwellNumber.ToString();
            self.FUIBuildingInfoWindow.m_Boom.text = buildingConfig.Boom.ToString();
            self.FUIBuildingInfoWindow.m_Comfort.text = buildingConfig.Comfortable.ToString();
            self.FUIBuildingInfoWindow.m_Durability.text = buildingConfig.Durable.ToString();
            
            self.UpdateBuildingDurability();
        }

        public static void UpdateBuildingDurability(this FUIBuildingInfoWindowComponent self)
        {
            var buildingConfig = StructureConfigCategory.Instance.Get(self.CurEditBuildingInfo.ConfigId);
            var progressBar = self.FUIBuildingInfoWindow.m_DurabilityProgressBar;
            progressBar.FGComp.max = buildingConfig.Durable;
            progressBar.FGComp.value = self.CurEditBuildingInfo.Durable;
            var durabilityLabel = self.FUIBuildingInfoWindow.m_DurabilityLabel;
            durabilityLabel.text = $"{self.CurEditBuildingInfo.Durable}/{buildingConfig.Durable}";
        }

        public static void OnRemoveBuildingButtonClick(this FUIBuildingInfoWindowComponent self)
        {
            if (self.CurEditBuildingInfo == null)
            {
                return;
            }
            Debug.Log(self.CurEditBuildingInfo.Id);

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            BuildingHelper.RemoveBuilding(unit, self.CurEditBuildingInfo).Coroutine();
            self.ZoneScene().GetComponent<FUIComponent>().HideWindow(FUI_BuildingInfoWindow.UIResName);
        }

        public static void OnRepairButtonClick(this FUIBuildingInfoWindowComponent self)
        {
            var repairWin = FUIComponent.Instance.ShowWindow<FUI_RepairBuildingWindow, FUIRepairBuildingWindowComponent>();
            repairWin.ShowInfo(self.CurEditBuildingInfo);
        }

        public static void OnLevelupButtonClick(this FUIBuildingInfoWindowComponent self)
        {
            var upgradeWin = FUIComponent.Instance.ShowWindow<FUI_BuildingUpgradeWindow, FUIBuildingUpgradeWindowComponent>();
            upgradeWin.ShowInfo(self.CurEditBuildingInfo);
        }
    } 
                
}