/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System.Collections.Generic;
using System.Runtime.CompilerServices;
using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIBuilding;
    public class FUIBuildingSelectWorkerWindowComponentAwakeSystem : AwakeSystem<FUIBuildingSelectWorkerWindowComponent>
    {
        public override void Awake(FUIBuildingSelectWorkerWindowComponent self)
        {
            self.Awake();
        }
    }

    [FriendClass(typeof(People))]
    [FriendClass(typeof(Construct))]
    public static partial class FUIBuildingSelectWorkerWindowComponentSystem
    {
        public static void Awake(this FUIBuildingSelectWorkerWindowComponent self)
        {
            self.FUIBuildingSelectWorkerWindow = self.Parent.GetComponent<FUI_BuildingSelectWorkerWindow>();
            var win = new FUIBuildingSelectWorkerWindow();
            win.OnWindowShow = self.OnWindowShow;
            self.Window = win;
            self.Window.contentPane = self.FUIBuildingSelectWorkerWindow.FGComp;
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Building_BuildingWorkerItem, typeof(BuildingWorkerItem));
            
            // init event
            self.FUIBuildingSelectWorkerWindow.m_AssignButton.FGComp.AddClickListenerAsync(self.OnAssignButtonClick);
        }

        public static void OnWindowShow(this FUIBuildingSelectWorkerWindowComponent self)
        {
            // self.ShowInfo();
        }

        public static void ShowInfo(this FUIBuildingSelectWorkerWindowComponent self, Construct construct)
        {
            self.Construct = construct;
            self.CurSelectedPeopleIds.Clear();
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();

            var list = self.FUIBuildingSelectWorkerWindow.m_WorkerList;
            
            list.RemoveChildrenToPool();
            foreach (var v in peopleComp.Children)
            {
                People people = (People)v.Value;
                BuildingWorkerItem item = (BuildingWorkerItem) list.AddItemFromPool();
                item.SetName(people.Name);
                var gender = people.GetGender();
                var strength = people.GetLabor();
                
                item.SetIcon(PeopleViewHelper.GetHeadIconUrlByGender(gender));
                item.SetStrength(strength);

                item.WorkCheckBox.data = people.Id;
                item.WorkCheckBox.onClick.Remove(self.OnWorkerCheckBoxClick);
                item.WorkCheckBox.onClick.Add(self.OnWorkerCheckBoxClick);

                int behave = people.GetBehaveType();
                long behaveTargetId = people.GetTargetId();
                item.SetStateMsg(TextHelper.GetPeopleStateMsg(behave));
                // check worker
                if (behave != ConstBehaveType.BEHAVE_IDLE)
                {
                    
                    var c = item.GetWorkingController();
                    if (behaveTargetId != construct.Id)
                    {
                        c.selectedIndex = 1;
                        item.WorkCheckBox.selected = false;
                    }
                    else
                    {
                        c.selectedIndex = 0;
                        item.WorkCheckBox.selected = true;
                    }
                }
                else
                {
                    item.WorkCheckBox.selected = false;
                }
            }
            
            self.RefreshCurrentWorkerInfo();
        }

        public static void RefreshCurrentWorkerInfo(this FUIBuildingSelectWorkerWindowComponent self)
        {
            List<long> curWorkers = new List<long>();
            curWorkers.AddRange(self.Construct.PeopleIdList);
            curWorkers.AddRange(self.Construct.PreparePeopleIdList);
            curWorkers.AddRange(self.CurSelectedPeopleIds);

            self.FUIBuildingSelectWorkerWindow.m_SelectedPeople.text = $"{curWorkers.Count}/{ConstValue.Construct_Need_MaxPeople}";

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            int totalLabor = 0;
            foreach (long curWorker in curWorkers)
            {
                var people = peopleComp.GetChild<People>(curWorker);
                totalLabor += people.GetLaborWithCoefficient();
            }

            var leftTime = (float) (self.Construct.Config.BodyVolume - self.Construct.Progress) / totalLabor * 5; // 因为每5s结算一次
            self.FUIBuildingSelectWorkerWindow.m_TimeText.text = Mathf.RoundToInt(leftTime) + "s";
        }

        public static void OnWorkerCheckBoxClick(this FUIBuildingSelectWorkerWindowComponent self, EventContext context)
        {
            var sender = context.sender as GButton;
            var id = (long)sender.data;
            Log.Info($"{id}|isSelected:[{sender.selected}]");
            if (sender.selected)
            {
                int totalNum = self.Construct.PeopleIdList.Count + self.Construct.PreparePeopleIdList.Count + self.CurSelectedPeopleIds.Count;
                if (totalNum >= ConstValue.Construct_Need_MaxPeople)
                {
                    sender.selected = false;
                    CommonHelper.ShowHint(self.ZoneScene(), TextConfigEnum.ID_1032);
                    return;
                }
                self.CurSelectedPeopleIds.Add(id);
            }
            else
            {
                self.CurSelectedPeopleIds.Remove(id);
            }
            
            self.RefreshCurrentWorkerInfo();
        }

        public static async  ETTask OnAssignButtonClick(this FUIBuildingSelectWorkerWindowComponent self)
        {
            if (self.CurSelectedPeopleIds.Count <= 0)
            {
                CommonHelper.ShowHint(self.ZoneScene(), TextConfigEnum.ID_1033);
                return;
            }
            

            foreach (var id in self.CurSelectedPeopleIds)
            {
                Log.Info($"Selected Id:[{id}]");
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            int result = await ConstructHelper.GoConstruct(unit, self.Construct.Id, self.CurSelectedPeopleIds);

            if (result == ErrorCode.ERR_Success)
            {
                Game.EventSystem.Publish(new EventType.ConstructUpdate(){Construct = self.Construct});
                var cView = self.Construct.GetComponent<ConstructViewComponent>();
                foreach (var id in self.CurSelectedPeopleIds)
                {
                    var peopleComp = unit.GetComponent<PeopleComponent>();
                    var p = peopleComp.GetChild<People>(id);
                    var pView = p.GetComponent<PeopleViewComponent>();
                    
                    pView.MoveToPos(cView.GetWorkerPos(id));
                }
            }

            self.Window.Hide();
            await ETTask.CompletedTask;
        }
    } 
                
}