/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System;
using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIBuilding;
    
    public class FUIBuildingUpgradeWindowComponentAwakeSystem : AwakeSystem<FUIBuildingUpgradeWindowComponent>
    {
        public override void Awake(FUIBuildingUpgradeWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(Building))]
    public static partial class FUIBuildingUpgradeWindowComponentSystem
    {
        public static void Awake(this FUIBuildingUpgradeWindowComponent self)
        {
            self.FUIBuildingUpgradeWindow = self.Parent.GetComponent<FUI_BuildingUpgradeWindow>();      
            self.Window = new Window();
            self.Window.contentPane = self.FUIBuildingUpgradeWindow.FGComp;
            
            // material button
            self.MaterialButtons = new FUI_MaterialButton[4]
            {
                self.FUIBuildingUpgradeWindow.m_Material1, 
                self.FUIBuildingUpgradeWindow.m_Material2, 
                self.FUIBuildingUpgradeWindow.m_Material3, 
                self.FUIBuildingUpgradeWindow.m_Material4
            };
            
            self.FUIBuildingUpgradeWindow.m_ConfirmButton.FGComp.AddClickListenerAsync(self.OnUpgradeButtonClick);
        }

        public static void ShowInfo(this FUIBuildingUpgradeWindowComponent self, Building building)
        {
            self.Building = building;
            self.CurUpgradeSynthesisConfigId = 0;
            
            var buildingConfig = StructureConfigCategory.Instance.Get(building.ConfigId);
            self.FUIBuildingUpgradeWindow.m_BuildingName.text = buildingConfig.Name;
            self.FUIBuildingUpgradeWindow.m_BuildingIcon.url = buildingConfig.Picture;
            self.FUIBuildingUpgradeWindow.m_AllowLivingNumber.text = buildingConfig.DwellNumber.ToString();
            self.FUIBuildingUpgradeWindow.m_Boom.text = buildingConfig.Boom.ToString();
            self.FUIBuildingUpgradeWindow.m_Comfort.text = buildingConfig.Comfortable.ToString();
            self.FUIBuildingUpgradeWindow.m_Durability.text = buildingConfig.Durable.ToString();

            if (building.Config.UpgradeSequence <= 0)
            {
                Log.Error($"No UpgradeSequence of {building.ConfigId}");
                return;
            }

            var upgradeConfig = UpgrateSequenceConfigCategory.Instance.Get(building.Config.UpgradeSequence);
            int index = Array.IndexOf(upgradeConfig.ItemId, building.ConfigId);
            if (index >= 0)
            {
                int nextIdx = index + 1;
                if (nextIdx < upgradeConfig.ItemId.Length)
                {
                    int nextBuildingConfigId = upgradeConfig.ItemId[nextIdx];
                    var nextBuildingConfig = StructureConfigCategory.Instance.Get(nextBuildingConfigId);
                    self.FUIBuildingUpgradeWindow.m_UpgradeBuildingName.text = nextBuildingConfig.Name;
                    self.FUIBuildingUpgradeWindow.m_UpgradeBuildingIcon.url = nextBuildingConfig.Picture;
                    self.FUIBuildingUpgradeWindow.m_UpgradeAllowLivingNumber.text = nextBuildingConfig.DwellNumber.ToString();
                    self.FUIBuildingUpgradeWindow.m_UpgradeBoom.text = nextBuildingConfig.Boom.ToString();
                    self.FUIBuildingUpgradeWindow.m_UpgradeComfort.text = nextBuildingConfig.Comfortable.ToString();
                    self.FUIBuildingUpgradeWindow.m_UpgradeDurability.text = nextBuildingConfig.Durable.ToString();

                    var synthesisConfig = SynthesisConfigCategory.Instance.GetSynthesisByMixture(SynthesisMixtureTpyeEnum.STRUCTURE, nextBuildingConfigId);
                    self.CurUpgradeSynthesisConfigId = synthesisConfig.Id;
                    if (synthesisConfig != null)
                    {
                        float discount = WorldParametersConfigCategory.Instance.GetUpgradePercent();
                        for (int i = 0; i < synthesisConfig.ItemId.Length; i++)
                        {
                            self.SetMaterialData(self.MaterialButtons[i], synthesisConfig.ItemId[i], (int)(synthesisConfig.ItemNum[i] * discount));
                        }
                        
                        for (int j = synthesisConfig.ItemId.Length; j < 4; j++)
                        {
                            self.MaterialButtons[j].Visible = false;
                        }
                        
                        if (synthesisConfig.UnlockCondition == (int) SynthesisUnlockConditionEnum.SCALECONFIG)
                        {
                            var scaleConfig = ScaleConfigCategory.Instance.Get(synthesisConfig.Parameter2);
                            self.FUIBuildingUpgradeWindow.m_ScaleName.text = scaleConfig.ScaleName;
                        }
                        else
                        {
                            Log.Error($"Unlock condition of ${nextBuildingConfigId} is not scale");
                        }
                    }
                }
                else
                {
                    Log.Warning($"Max level of building:{building.ConfigId}");
                }
            }
            else
            {
                Log.Error($"Can't find upgrade sequence of {building.ConfigId}");
            }
        }
        
        public static void SetMaterialData(this FUIBuildingUpgradeWindowComponent self, FUI_MaterialButton materialButton, int materialId, int needNum)
        {
            if (materialId <= 0)
            {
                materialButton.Visible = false;
                return;
            }
            
            // 获取当前材料的数量
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            var curNum = storeComp.GetItemNum(materialId);
            
            materialButton.Visible = true;
            materialButton.FGComp.data = materialId;
            materialButton.m_CurrentNum.text = curNum.ToString();
            if (curNum >= needNum)
            {
                materialButton.m_CurrentNum.color = Color.green;
            }
            else
            {
                materialButton.m_CurrentNum.color = Color.red;
            }
            materialButton.m_NeedNum.text = needNum.ToString();
            var itemConfig = AllItemConfigCategory.Instance.Get(materialId);
            // materialButton.m_Icon.SetSize(100, 100);
            
            materialButton.m_Icon.url = $"ui://AllItem/{itemConfig.Icon}";
        }

        public static async ETTask OnUpgradeButtonClick(this FUIBuildingUpgradeWindowComponent self)
        {
            if (self.CurUpgradeSynthesisConfigId <= 0)
            {
                return;
            }
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            int result = await ConstructHelper.CreateConstruct(unit, self.CurUpgradeSynthesisConfigId, self.Building.Position.x, self.Building.Position.y,
                self.Building.Id);

            if (result == ErrorCode.ERR_Success)
            {
                // 删除原来建筑的表现,等待新房子建成换成新的
                self.Building.RemoveComponent<BuildingViewComponent>();
                
                self.Window.Hide();                
            }
        }
    } 
                
}