/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System;
using FairyGUI;
using UnityEngine;
using UnityEngine.Search;

namespace ET
{
    using FUIBuilding;
    using FUIMain;
    public class FUIBuildingWindowComponentAwakeSystem : AwakeSystem<FUIBuildingWindowComponent>
    {
        public override void Awake(FUIBuildingWindowComponent self)
        {
            self.Awake();
        }
    }
    
    [FriendClass(typeof(OperationComponent))]
    [FriendClass(typeof(MapComponent))]
    public static partial class FUIBuildingWindowComponentSystem
    {
        public static void Awake(this FUIBuildingWindowComponent self)
        {
            self.FUIBuildingWindow = self.Parent.GetComponent<FUI_BuildingWindow>();
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Building_BuildingItem, typeof(BuildingItem));

            // self.RefreshBuildingItems();
            self.FUIBuildingWindow.m_CreateButton.FGComp.onClick.Add(self.OnCreateButtonClick);
            self.FUIBuildingWindow.m_tab.onChanged.Add(self.OnTabChanged);

            FUIBuildingWindow win = new FUIBuildingWindow();
            win.contentPane = self.FUIBuildingWindow.FGComp;
            win.OnWindowShow = self.OnWindowShow;
            self.Window = win;
            
            // material button
            self.MaterialButtons = new FUI_MaterialButton[4]
            {
                self.FUIBuildingWindow.m_Material1, self.FUIBuildingWindow.m_Material2, self.FUIBuildingWindow.m_Material3, self.FUIBuildingWindow.m_Material4
            };
            
            foreach (FUI_MaterialButton fuiBuildingMaterialButton in self.MaterialButtons)
            {
                fuiBuildingMaterialButton.FGComp.onClick.Add(self.OnMaterialButtonClick);
            }
            
            self.FUIBuildingWindow.m_MaterialInfoPopup.Visible = false;
        }
        
        public static void OnWindowShow(this FUIBuildingWindowComponent self)
        {
            // 加载所有Item资源
            self.ZoneScene().GetComponent<FUIPackageComponent>().AddPackage(FUIPackage.AllItem);
            self.RefreshBuildingItems();
        }

        public static void RefreshBuildingItems(this FUIBuildingWindowComponent self)
        {
            var synthesisConfigs = SynthesisConfigCategory.Instance.GetAll();
            var list = self.FUIBuildingWindow.m_BuildingList;

            var unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var buildingComp = unit.GetComponent<BuildingComponent>();

            list.RemoveChildrenToPool();
            int i = 0;
            foreach (var config in synthesisConfigs)
            {
                var synConfig = (SynthesisConfig) config.Value;
                if (synConfig.MixtureTpye == (int)MixtureType.Building) // 建筑
                {
                    StructureConfig buildingConfig = null;
                    try
                    {
                        buildingConfig = StructureConfigCategory.Instance.Get(synConfig.MixtureID);
                    }
                    catch (Exception e)
                    {
                        Console.WriteLine(e);
                    }

                    if (buildingConfig == null)
                    {
                        continue;
                    }
                    if (buildingConfig.Type == self.CurSelectBuildingType)
                    {
                        BuildingItem item = (BuildingItem) list.AddItemFromPool();
                        item.onClick.Remove(self.OnBuildingItemClick);
                        item.SetName(config.Value.Name);
                        item.SetOwnNum(buildingComp.GetBuildingNum(buildingConfig.Id));
                        string iconUrl = $"{buildingConfig.Picture}";
                        item.SetIcon(iconUrl);
                        item.data = config.Value.Id;
                        item.onClick.Add(self.OnBuildingItemClick);
                        item.SetCanBuildNum(self.CalcCanBuildNum(config.Value));


                        if (self.CurSelectBuildingSynthesisId == 0)
                        {
                            // 默认选中第一个
                            self.CurSelectBuildingSynthesisId = synConfig.Id;
                        }

                        if (synConfig.Id == self.CurSelectBuildingSynthesisId)
                        {
                            list.AddSelection(i, true);
                            self.SetBuildingDetailDesc(config.Value.Id);
                        }
                    
                        i++;
                    }  
                }

            }
        }

        private static int CalcCanBuildNum(this FUIBuildingWindowComponent self, SynthesisConfig synthesisConfig)
        {
            int canBuildNum = 0;
            if (synthesisConfig != null)
            {
                Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                var storeComp = unit.GetComponent<StoreComponent>();
                for (int i = 0; i < synthesisConfig.ItemId.Length; i++)
                {
                    int matId = synthesisConfig.ItemId[i];
                    int needNum = synthesisConfig.ItemNum[i];
                    
                    // 获取当前材料的数量

                    var curNum = storeComp.GetItemNum(matId);
                    int supportNum = (int) (curNum / needNum);
                    if (i == 0)
                    {
                        canBuildNum = supportNum;
                    }
                    else
                    {
                        canBuildNum = Mathf.Min(canBuildNum, supportNum);
                    }
                }
            }

            return canBuildNum;
        }

        public static void OnBuildingItemClick(this FUIBuildingWindowComponent self, EventContext context)
        {
            int id = (int)(context.sender as GObject).data;
            self.CurSelectBuildingSynthesisId = id;
            self.SetBuildingDetailDesc(id);
        }

        public static void SetBuildingDetailDesc(this FUIBuildingWindowComponent self, int id)
        {
            var synConfig = SynthesisConfigCategory.Instance.Get(id);
            var buildingConfig = StructureConfigCategory.Instance.Get(synConfig.MixtureID);
            self.FUIBuildingWindow.m_Desc.text = buildingConfig.Describe;
            self.FUIBuildingWindow.m_BuildingName.text = buildingConfig.Name;
            string iconUrl = $"{buildingConfig.Picture}";
            self.FUIBuildingWindow.m_DetailIcon.url = iconUrl;
            self.FUIBuildingWindow.m_AllowLivingNumber.text = buildingConfig.DwellNumber.ToString();
            self.FUIBuildingWindow.m_Boom.text = buildingConfig.Boom.ToString();
            self.FUIBuildingWindow.m_Comfort.text = buildingConfig.Comfortable.ToString();
            self.FUIBuildingWindow.m_Durability.text = buildingConfig.Durable.ToString();

            var synthesisConfig = SynthesisConfigCategory.Instance.Get(id);

            if (synthesisConfig != null)
            {
                for (int i = 0; i < synthesisConfig.ItemId.Length; i++)
                {
                    self.SetMaterialData(self.MaterialButtons[i], synthesisConfig.ItemId[i], synthesisConfig.ItemNum[i]);
                }

                for (int j = synthesisConfig.ItemId.Length; j < 4; j++)
                {
                    self.MaterialButtons[j].Visible = false;
                }
            }
        }

        public static void SetMaterialData(this FUIBuildingWindowComponent self, FUI_MaterialButton materialButton, int materialId, int needNum)
        {
            if (materialId <= 0)
            {
                materialButton.Visible = false;
                return;
            }
            
            // 获取当前材料的数量
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            var curNum = storeComp.GetItemNum(materialId);
            
            materialButton.Visible = true;
            materialButton.FGComp.data = materialId;
            materialButton.m_CurrentNum.text = curNum.ToString();
            if (curNum >= needNum)
            {
                materialButton.m_CurrentNum.color = Color.green;
            }
            else
            {
                materialButton.m_CurrentNum.color = Color.red;
            }
            materialButton.m_NeedNum.text = needNum.ToString();
            var itemConfig = AllItemConfigCategory.Instance.Get(materialId);
            // materialButton.m_Icon.SetSize(100, 100);
            
            materialButton.m_Icon.url = $"ui://AllItem/{itemConfig.Icon}";
        }

        public static void OnMaterialButtonClick(this FUIBuildingWindowComponent self, EventContext context)
        {
            var button = context.sender as GObject;
            int materialId = (int)button.data;
            
            // 获取当前材料的数量
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            var curNum = storeComp.GetItemNum(materialId);

            // 取道具表里的信息
            var itemConfig = AllItemConfigCategory.Instance.Get(materialId);
            
            self.FUIBuildingWindow.m_MaterialInfoPopup.m_Name.text = itemConfig.Name;
            self.FUIBuildingWindow.m_MaterialInfoPopup.m_CurrentNum.text = curNum.ToString();
            self.FUIBuildingWindow.m_MaterialInfoPopup.m_MaterialDesc.text = itemConfig.Description;
            self.FUIBuildingWindow.m_MaterialInfoPopup.m_MaterialSourceDesc.text = itemConfig.GetMethod;
            self.FUIBuildingWindow.m_MaterialInfoPopup.Visible = true;
            GRoot.inst.ShowPopup(self.FUIBuildingWindow.m_MaterialInfoPopup.FGComp, button);
        }

        public static void OnCreateButtonClick(this FUIBuildingWindowComponent self)
        {
            if (self.CurSelectBuildingSynthesisId == 0)
            {
                return;
            }

            var synConfig = SynthesisConfigCategory.Instance.Get(self.CurSelectBuildingSynthesisId);
            int canBuildNum = self.CalcCanBuildNum(synConfig);
            if (canBuildNum <= 0)
            {
                CommonHelper.ShowHint(self.ZoneScene(), TextConfigEnum.ID_1006);
                return;
            }
  
            var buildingConfig = StructureConfigCategory.Instance.Get(synConfig.MixtureID);
            // 在地图中创建建筑实例
            var mapComp = self.ZoneScene().CurrentScene().GetComponent<MapComponent>();
            GameObject building = self.InstantiateSync(buildingConfig.Prefab.ToPrefabAddress(), mapComp.BuildingRoot);

            // 添加编辑控件
            var createBuildingComp = self.ZoneScene().CurrentScene().AddComponent<CreateBuildingViewComponent>();
            createBuildingComp.Edit(building.transform, self.CurSelectBuildingSynthesisId);
			
            // 禁用正常地图操作
            self.ZoneScene().CurrentScene().GetComponent<OperationComponent>().Enabled = false;

            // 隐藏所有UI
            self.ZoneScene().GetComponent<FUIComponent>().HideWindow(FUI_BuildingWindow.UIResName);
            self.ZoneScene().GetComponent<FUIComponent>().HideUI(FUI_Main.UIResName);
        }

        public static void OnTabChanged(this FUIBuildingWindowComponent self)
        {
            var index = self.FUIBuildingWindow.m_tab.selectedIndex;
            self.CurSelectBuildingType = index + 1;
            Log.Debug("CurSelectBuildingType: " + self.CurSelectBuildingType);
            self.RefreshBuildingItems();
        }
    } 
                
}