/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using ET.FUIResource;
using FairyGUI;
using UnityEngine;
using UnityEngine.Rendering;

namespace ET
{
    using FUIBuilding;
    
    public class FUIFarmlandBatchWindowComponentAwakeSystem : AwakeSystem<FUIFarmlandBatchWindowComponent>
    {
        public override void Awake(FUIFarmlandBatchWindowComponent self)
        {
            self.Awake();
        }
    }

    [FriendClass(typeof(Building))]
    [FriendClass(typeof(Farmland))]
    [FriendClass(typeof(People))]
    [FriendClass(typeof(Cabin))]
    public static partial class FUIFarmlandBatchWindowComponentSystem
    {
        public static void Awake(this FUIFarmlandBatchWindowComponent self)
        {
            self.FUIFarmlandBatchWindow = self.Parent.GetComponent<FUI_FarmlandBatchWindow>();
            var win = new FUIFarmlandBatchWindow();
            win.OnWindowHide = self.OnHide;
            self.Window = win;
            self.Window.contentPane = self.FUIFarmlandBatchWindow.FGComp;
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Building_PlantSeedItem, typeof(PlantSeedItem));
            
            self.CameraComp = self.ZoneScene().CurrentScene().GetComponent<CameraComponent>();
            
            // events
            self.FUIFarmlandBatchWindow.m_PlantSeedList.onClickItem.Add(self.OnSeedItemClick);
            self.FUIFarmlandBatchWindow.m_AddFarmerButton.FGComp.onClick.Add(self.OnAddFarmerButtonClick);
            self.FUIFarmlandBatchWindow.m_CancelFarmerButton.FGComp.AddClickListenerAsync(self.OnCancelFarmerButtonClick);
            self.FUIFarmlandBatchWindow.m_GrowSpeedUpButton.FGComp.AddClickListenerAsync(self.OnGrowSpeedUpButtonClick);
            self.FUIFarmlandBatchWindow.m_CloseButton.FGComp.onClick.Add(self.OnCloseButtonClick);
            
            self.FUIFarmlandBatchWindow.FGComp.onTouchBegin.Add(self.OnTouchBegin);
            self.FUIFarmlandBatchWindow.FGComp.onTouchMove.Add(self.OnTouchMove);
            self.FUIFarmlandBatchWindow.FGComp.onTouchEnd.Add(self.OnTouchEnd);

            if (Application.platform is RuntimePlatform.WindowsEditor or RuntimePlatform.WindowsPlayer)
            {
                Stage.inst.onTouchMove.Add(self.OnGlobalTouchMove);
            }

        }
        
        public static void ShowInfo(this FUIFarmlandBatchWindowComponent self, Building building)
        {
            if (self.IsInBatchOperating)
            {
                return;
            }
            self.Building = building;
            self.Farmland = self.Building.GetChildByType<Farmland>();
            if (self.Farmland == null)
            {
                Log.Error($"Building [{self.Building.Id}] doesn't have a Farmland");
                return;
            }

            self.CurBatchOperate = BatchOperate.None;

            if (self.Farmland.CabinId <= 0)
            {
                Log.Error($"Farmland [{self.Farmland.Id}] doesn't belong to a cabin");
                return;
            }

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());

            var cabin = unit.GetGrandChild<Cabin>(self.Farmland.CabinId);
            if (cabin == null)
            {
                Log.Error($"Cabin [{self.Farmland.CabinId}] doesn't find");
                return;
            }

            self.Cabin = cabin;
            
            // 显示小屋农民信息
            self.ShowFarmer();
            
            self.FarmlandGroup.Clear();
            foreach (long cabinFarmlandId in cabin.FarmlandIds)
            {
                var farmland = unit.GetGrandChild<Farmland>(cabinFarmlandId);
                self.FarmlandGroup.Add(farmland);
                var farmlandBuilding = farmland.GetParent<Building>();

                var buildingView = farmlandBuilding.GetComponent<BuildingViewComponent>();
                if (farmland == self.Farmland)
                {
                    // 高亮并描边当前选中的田
                    buildingView?.HighlightBuilding(true);   
                }
                else
                {
                    // 高亮被一起管理的田
                    buildingView?.HighlightBuilding();   
                }
            }

            self.FUIFarmlandBatchWindow.m_farmlandState.selectedIndex = self.Farmland.FarmlandState;

            // 根据农田状态来显示不同信息界面
            switch (self.Farmland.FarmlandState)
            {
                case FarmlandState.FARMLAND_STATE_FREE:
                    self.CurBatchOperate = BatchOperate.Seed;
                    self.ShowSeedPanel();
                    break;
                case FarmlandState.FARMLAND_STATE_SEED:
                    self.ShowWaitForPlantPanel();
                    break;
                case FarmlandState.FARMLAND_STATE_GROW:
                    self.ShowGrowPanel();
                    break;
                case FarmlandState.FARMLAND_STATE_RIPE:
                    self.CurBatchOperate = BatchOperate.Harvest;
                    self.ShowHarvestPanel();
                    break;
            }
        }

        public static void Refresh(this FUIFarmlandBatchWindowComponent self)
        {
            self.ShowInfo(self.Building);
        }
        
        // 当农田状态发生改变时，检查当前是否打开改变农田的界面，进行更新
        public static void CheckToRefresh(this FUIFarmlandBatchWindowComponent self, Farmland farmland)
        {
            if (self.Farmland == farmland)
            {
                self.Refresh();
            }
        }

        public static void ShowFarmer(this FUIFarmlandBatchWindowComponent self)
        {
            if (self.Farmland == null)
            {
                Log.Error($"Building [{self.Building.Id}] doesn't have a Farmland");
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            if (self.Cabin == null)
            {
                Log.Error($"Cabin [{self.Farmland.CabinId}] doesn't find");
                return;
            }

            if (self.Cabin.PeopleId <= 0)
            {
                self.FUIFarmlandBatchWindow.m_hasPeople.selectedIndex = 0;
                return;
            }
            
            self.FUIFarmlandBatchWindow.m_hasPeople.selectedIndex = 1;

            var peopleComp = unit.GetComponent<PeopleComponent>();
            var people = peopleComp.GetChild<People>(self.Cabin.PeopleId);
            if (people == null)
            {
                Log.Error($"Can't find people of Id [{self.Cabin.PeopleId}] in cabin");
                return;
            }

            self.FUIFarmlandBatchWindow.m_Farmer_Icon.url = PeopleViewHelper.GetHeadIconUrlByGender(people.GetGender());
            self.FUIFarmlandBatchWindow.m_Farmer_Name.text = people.Name;
            self.FUIFarmlandBatchWindow.m_Farmer_Labor.text = people.Labor.ToString();

            if (people.GetBehaveType() == ConstBehaveType.BEHAVE_PREPARE_CABIN)
            {
                self.FUIFarmlandBatchWindow.m_PeopleState.visible = true;
            }
            else
            {
                self.FUIFarmlandBatchWindow.m_PeopleState.visible = false;
            }
        }

        #region Panels
        public static void ShowSeedPanel(this FUIFarmlandBatchWindowComponent self)
        {
            if (Application.platform is RuntimePlatform.WindowsEditor or RuntimePlatform.WindowsPlayer)
            {
                self.FUIFarmlandBatchWindow.m_PlantSeedCursor.visible = true;
            }
            
            self.FUIFarmlandBatchWindow.m_SeedInfoPopup.Visible = false;
            var list = self.FUIFarmlandBatchWindow.m_PlantSeedList;

            var cropConfigList = CropConfigCategory.Instance.GetList();
            
            // 获取当前种子的数量
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            
            list.RemoveChildrenToPool();
            for (int i = 0; i < cropConfigList.Count; i++)
            {
                CropConfig cropConfig = cropConfigList[i];
                var item = (PlantSeedItem)list.AddItemFromPool();
                item.data = cropConfig;
                item.Name.text = cropConfig.Name;
                item.Icon.url = cropConfig.CropPic;
                
                var itemConfig = AllItemConfigCategory.Instance.Get(cropConfig.SeedNeed);
                var curNum = storeComp.GetItemNum(itemConfig.Id);
                
                // TODO: 暂时去掉季节判断
                // if (!cropConfig.Season.Contains(unit.Season))
                // {
                //     item.SetSeedState(SeedState.NOT_AVAILABLE);
                // }
                // else
                if (curNum < cropConfig.SeedNum)
                {
                    item.SetSeedState(SeedState.NOT_NOT_ENOUGH);
                }
                else
                {
                    item.SetSeedState(SeedState.OK);
                }
                
                if (i == 0)
                {
                    list.selectedIndex = 0;
                    self.SelectSeedItem(item);
                }
            }
        }
        
        public static void ShowWaitForPlantPanel(this FUIFarmlandBatchWindowComponent self)
        {
            var cropConfig = self.Farmland.Config;
            if (cropConfig == null)
            {
                return;
            }

            self.FUIFarmlandBatchWindow.m_WaitForPlant_CropIcon.url = cropConfig.CropPic;
        }

        public static void ShowGrowPanel(this FUIFarmlandBatchWindowComponent self)
        {
            var cropConfig = self.Farmland.Config;
            if (cropConfig == null)
            {
                return;
            }

            self.FUIFarmlandBatchWindow.m_Grow_CropIcon.url = cropConfig.CropPic;

            int day = GameUtil.GetDaysOfTime(cropConfig.GrowthCycle);
            self.FUIFarmlandBatchWindow.m_GrowText.text = TextHelper.GetGrowUpTimeText(day);
            self.FUIFarmlandBatchWindow.m_Grow_ProductionNum.text = cropConfig.BasicProduction.ToString();
        }
        
        public static void ShowHarvestPanel(this FUIFarmlandBatchWindowComponent self)
        {
            if (Application.platform is RuntimePlatform.WindowsEditor or RuntimePlatform.WindowsPlayer)
            {
                self.FUIFarmlandBatchWindow.m_HarvestCursor.visible = true;
            }

            var cropConfig = self.Farmland.Config;
            if (cropConfig == null)
            {
                return;
            }

            self.FUIFarmlandBatchWindow.m_Harvest_CropIcon.url = cropConfig.CropPic;
         
            self.FUIFarmlandBatchWindow.m_Harvest_ProductionNum.text = cropConfig.BasicProduction.ToString();
        }

        #endregion
        public static void OnAddFarmerButtonClick(this FUIFarmlandBatchWindowComponent self)
        {
            self.SelectFarmer().Coroutine();
        }

        public static async ETTask OnCancelFarmerButtonClick(this FUIFarmlandBatchWindowComponent self)
        {
            if (self.Farmland == null)
            {
                Log.Error($"Building [{self.Building.Id}] doesn't have a Farmland");
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            if (self.Cabin == null)
            {
                Log.Error($"Cabin [{self.Farmland.CabinId}] doesn't find");
                return;
            }

            if (self.Cabin.PeopleId <= 0)
            {
                self.FUIFarmlandBatchWindow.m_hasPeople.selectedIndex = 0;
                return;
            }
            
            var peopleComp = unit.GetComponent<PeopleComponent>();
            var people = peopleComp.GetChild<People>(self.Cabin.PeopleId);
            if (people == null)
            {
                Log.Error($"Can't find people of Id [{self.Cabin.PeopleId}] in cabin");
                return;
            }
            
            await PeopleHelper.ChangeBehave(unit, people, 0, ConstBehaveType.BEHAVE_IDLE);
            
            self.Refresh();
        }

        public static async ETTask SelectFarmer(this FUIFarmlandBatchWindowComponent self)
        {
            var selectWorkerWin = FUIComponent.Instance.ShowWindow<FUI_SelectWorkerWindow, FUISelectWorkerWindowComponent>();
            var workers = await selectWorkerWin.ShowAsync(1);
            if (workers.Count <= 0)
            {
                return;
            }

            var workerId = workers[0];
            if (workerId <= 0)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            var worker = peopleComp.GetChild<People>(workerId);
            await CabinHelper.GoCabin(unit, worker, self.Cabin);
            self.Refresh();
        }
        
        public static void SelectSeedItem(this FUIFarmlandBatchWindowComponent self, PlantSeedItem plantSeedItem)
        {
            var cropConfig = (CropConfig) plantSeedItem.data;
            self.CurSelectCrop = cropConfig;

            var itemConfig = AllItemConfigCategory.Instance.Get(cropConfig.SeedNeed);
            
            // 获取当前种子的数量
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            var curNum = storeComp.GetItemNum(itemConfig.Id);

            var popup = self.FUIFarmlandBatchWindow.m_SeedInfoPopup;
            popup.m_Name.text = cropConfig.Name;
            
            popup.m_NeedNum.text = $"{curNum}/{cropConfig.SeedNum}";
            string seasonStr = "";
            int[] seasonArray = cropConfig.Season;
            for (int i = 0; i < seasonArray.Length; i++)
            {
                seasonStr += TextHelper.GetSeasonText(seasonArray[i]);
                if (seasonArray.Length > 1 && i < seasonArray.Length - 1)
                {
                    seasonStr += ",";
                }
            }
            popup.m_Season.text = seasonStr;
            popup.m_GrowTime.text = cropConfig.GrowthCycle.ToString();
            popup.Visible = true;
            GRoot.inst.ShowPopup(popup.FGComp, plantSeedItem);
        }

        public static void OnSeedItemClick(this FUIFarmlandBatchWindowComponent self, EventContext context)
        {
            var plantSeedItem = (PlantSeedItem) context.data;
            self.SelectSeedItem(plantSeedItem);
        }
        
        public static async ETTask OnGrowSpeedUpButtonClick(this FUIFarmlandBatchWindowComponent self)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            int result = await FarmlandHelper.FarmlandRipe(unit, self.Farmland.Id);
        }

        public static void SetIsBatchOperating(this FUIFarmlandBatchWindowComponent self, bool isBatching)
        {
            self.IsInBatchOperating = isBatching;
            self.FUIFarmlandBatchWindow.m_isBatchOperating.selectedIndex = isBatching? 1 : 0;
        }

        public static void CheckToDoBatchOperate(this FUIFarmlandBatchWindowComponent self, Vector2 screenPos)
        {
            if (self.CurBatchOperate == BatchOperate.None)
            {
                return;
            }

            
            
            Vector3 worldPos = self.CameraComp.ScreenToWorldPoint(screenPos);

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            
            foreach (Farmland farmland in self.FarmlandGroup)
            {
                var building = farmland.GetParent<Building>();
                var buildingView = building.GetComponent<BuildingViewComponent>();
                if (buildingView.IsPointInClickArea(worldPos))
                {
                    if (!self.CurBatchOperateFarmlands.Contains(farmland))
                    {
                        switch (self.CurBatchOperate)
                        {
                            case BatchOperate.Seed:
                                if (farmland.FarmlandState == FarmlandState.FARMLAND_STATE_FREE)
                                {
                                    self.CurBatchOperateFarmlands.Add(farmland);
                                    CabinHelper.CabinSeed(unit, farmland, self.CurSelectCrop.Id).Coroutine();
                                    self.SetIsBatchOperating(true);
                                }
                                break;
                            case BatchOperate.Harvest:
                                if (farmland.FarmlandState == FarmlandState.FARMLAND_STATE_RIPE)
                                {
                                    self.CurBatchOperateFarmlands.Add(farmland);
                                    CabinHelper.CabinHarvest(unit, farmland).Coroutine();
                                    self.SetIsBatchOperating(true);
                                }
                                break;
                        }
                    }
                }
            }
        }

        public static bool IsOnUI(this FUIFarmlandBatchWindowComponent self)
        {
            // 除子UI元素的其它窗口区域都认为是非UI
            if (Stage.inst.touchTarget == self.FUIFarmlandBatchWindow.FGComp.displayObject)
            {
                return false;
            }

            return true;
        }
        
        public static void OnTouchBegin(this FUIFarmlandBatchWindowComponent self, EventContext eventContext)
        {
            if (self.CurBatchOperate == BatchOperate.None)
            {
                return;
            }

            if (self.IsOnUI())
            {
                return;
            }
            
            eventContext.CaptureTouch();
            
            self.CurTouchPos.Set(eventContext.inputEvent.x, Screen.height - eventContext.inputEvent.y);
            self.CheckToDoBatchOperate(self.CurTouchPos);
        }
        
        public static void OnTouchMove(this FUIFarmlandBatchWindowComponent self, EventContext eventContext)
        {
            self.CurTouchPos.Set(eventContext.inputEvent.x, Screen.height - eventContext.inputEvent.y);
            self.CheckToDoBatchOperate(self.CurTouchPos);
        }

        public static void OnTouchEnd(this FUIFarmlandBatchWindowComponent self, EventContext eventContext)
        {
            self.CurBatchOperateFarmlands.Clear();
            

            // 批量操作后关闭窗口，因为可能选中的田会发生状态改变，造成操作改变
            if (self.IsInBatchOperating)
            {
                self.SetIsBatchOperating(false);
                self.Hide();
            }
        }


        public static void OnGlobalTouchMove(this FUIFarmlandBatchWindowComponent self, EventContext eventContext)
        {
            switch (self.CurBatchOperate)
            {
                case BatchOperate.Seed:
                     //self.FUIFarmlandBatchWindow.m_PlantSeedCursor.visible = true;
                     self.FUIFarmlandBatchWindow.m_PlantSeedCursor.position = eventContext.inputEvent.position;

                    break;
                case BatchOperate.Harvest:
                    //self.FUIFarmlandBatchWindow.m_HarvestCursor.visible = true;
                    self.FUIFarmlandBatchWindow.m_HarvestCursor.position = eventContext.inputEvent.position;

                    break;
            }
        }

        public static void OnHide(this FUIFarmlandBatchWindowComponent self)
        {
            var buildingView = self.Building.GetComponent<BuildingViewComponent>();
            buildingView?.NormalBuilding();
            
            foreach (Farmland farmland in self.FarmlandGroup)
            {
                if (farmland == self.Farmland)
                {
                    continue;
                }
                var farmlandBuilding = farmland.GetParent<Building>();
                buildingView = farmlandBuilding.GetComponent<BuildingViewComponent>();
                buildingView?.NormalBuilding();
            }

            self.SetIsBatchOperating(false);
        }

        public static void Hide(this FUIFarmlandBatchWindowComponent self)
        {
            self.Window.Hide();
        }

        public static void OnCloseButtonClick(this FUIFarmlandBatchWindowComponent self)
        {
            self.Hide();
        }
    } 
                
}