/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System.Collections.Generic;
using ET.FUIResource;
using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIBuilding;
    
    public class FUIFarmlandWindowComponentAwakeSystem : AwakeSystem<FUIFarmlandWindowComponent>
    {
        public override void Awake(FUIFarmlandWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(Unit))]
    [FriendClass(typeof(Farmland))]
    [FriendClass(typeof(People))]
    public static partial class FUIFarmlandWindowComponentSystem
    {
        public static void Awake(this FUIFarmlandWindowComponent self)
        {
            self.FUIFarmlandWindow = self.Parent.GetComponent<FUI_FarmlandWindow>();      
            var win = new FUIFarmlandWindow();
            win.OnWindowHide = self.OnHide;
            self.Window = win;
            self.Window.contentPane = self.FUIFarmlandWindow.FGComp;
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Building_PlantSeedItem, typeof(PlantSeedItem));

            // events
            self.FUIFarmlandWindow.m_PlantSeedList.onClickItem.Add(self.OnSeedItemClick);
            self.FUIFarmlandWindow.m_ConfirmSeedButton.FGComp.AddClickListenerAsync(self.OnSeedConfirmButtonClick);
            self.FUIFarmlandWindow.m_WFP_FarmerIconButton.FGComp.onClick.Add(self.OnAddPlantPeopleButtonClick);
            self.FUIFarmlandWindow.m_AddPlantPeopleButton.FGComp.onClick.Add(self.OnAddPlantPeopleButtonClick);
            self.FUIFarmlandWindow.m_GrowSpeedUpButton.FGComp.AddClickListenerAsync(self.OnGrowSpeedUpButtonClick);
            self.FUIFarmlandWindow.m_Harvest_FarmerIconButton.FGComp.onClick.Add(self.OnHarvestButtonClick);
            self.FUIFarmlandWindow.m_HarvestButton.FGComp.onClick.Add(self.OnHarvestButtonClick);
            
            self.FUIFarmlandWindow.m_RemoveButton.FGComp.onClick.Add(self.OnRemoveButtonClick);
            self.FUIFarmlandWindow.m_CloseButton.FGComp.onClick.Add(self.OnCloseButtonClick);
        }

        public static void ShowInfo(this FUIFarmlandWindowComponent self, Building building)
        {
            self.Building = building;
            self.Farmland = self.Building.GetChildByType<Farmland>();
            if (self.Farmland == null)
            {
                Log.Error($"Building [{self.Building.Id}] doesn't have a Farmland");
                return;
            }
            
            // highlight
            var buildingView = self.Building.GetComponent<BuildingViewComponent>();
            buildingView?.HighlightBuilding(true);
            

            self.FUIFarmlandWindow.m_farmlandState.selectedIndex = self.Farmland.FarmlandState;

            switch (self.Farmland.FarmlandState)
            {
                case FarmlandState.FARMLAND_STATE_FREE:
                    self.ShowSeedPanel();
                    break;
                case FarmlandState.FARMLAND_STATE_SEED:
                    self.ShowWaitForPlantPanel();
                    break;
                case FarmlandState.FARMLAND_STATE_GROW:
                    self.ShowGrowPanel();
                    break;
                case FarmlandState.FARMLAND_STATE_RIPE:
                    self.ShowHarvestPanel();
                    break;
            }
        }

        public static void Refresh(this FUIFarmlandWindowComponent self)
        {
            self.ShowInfo(self.Building);
        }

        // 当农田状态发生改变时，检查当前是否打开改变农田的界面，进行更新
        public static void CheckToRefresh(this FUIFarmlandWindowComponent self, Farmland farmland)
        {
            if (self.Farmland == farmland)
            {
                self.Refresh();
            }
        }

        public static void ShowSeedPanel(this FUIFarmlandWindowComponent self)
        {
            
            self.FUIFarmlandWindow.m_SeedInfoPopup.Visible = false;
            var list = self.FUIFarmlandWindow.m_PlantSeedList;

            var cropConfigList = CropConfigCategory.Instance.GetList();
            
            // 获取当前种子的数量
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            
            list.RemoveChildrenToPool();
            for (int i = 0; i < cropConfigList.Count; i++)
            {
                CropConfig cropConfig = cropConfigList[i];
                var item = (PlantSeedItem)list.AddItemFromPool();
                item.data = cropConfig;
                item.Name.text = cropConfig.Name;
                item.Icon.url = cropConfig.CropPic;
                
                var itemConfig = AllItemConfigCategory.Instance.Get(cropConfig.SeedNeed);
                var curNum = storeComp.GetItemNum(itemConfig.Id);
                
                // TODO: 暂时去掉季节判断
                // if (!cropConfig.Season.Contains(unit.Season))
                // {
                //     item.SetSeedState(SeedState.NOT_AVAILABLE);
                // }
                // else
                if (curNum < cropConfig.SeedNum)
                {
                    item.SetSeedState(SeedState.NOT_NOT_ENOUGH);
                }
                else
                {
                    item.SetSeedState(SeedState.OK);
                }
                
                if (i == 0)
                {
                    list.selectedIndex = 0;
                    self.SelectSeedItem(item);
                }
            }
        }

        public static void ShowWaitForPlantPanel(this FUIFarmlandWindowComponent self)
        {
            var cropConfig = self.Farmland.Config;
            if (cropConfig == null)
            {
                return;
            }

            self.FUIFarmlandWindow.m_WaitForPlant_CropIcon.url = cropConfig.CropPic;

            if (self.Farmland.PeopleId > 0)
            {
                self.FUIFarmlandWindow.m_hasPeople.selectedIndex = 1;
                
                Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                var peopleComp = unit.GetComponent<PeopleComponent>();
                var people = peopleComp.GetChild<People>(self.Farmland.PeopleId);
                self.FUIFarmlandWindow.m_WFP_FarmerIconButton.m_Icon.url = PeopleViewHelper.GetHeadIconUrlByGender(people.GetGender());
                self.FUIFarmlandWindow.m_WFP_FarmerIconButton.m_Name.text = people.Name;
            }
            else
            {
                self.FUIFarmlandWindow.m_hasPeople.selectedIndex = 0;
            }
        }

        public static void ShowGrowPanel(this FUIFarmlandWindowComponent self)
        {
            var cropConfig = self.Farmland.Config;
            if (cropConfig == null)
            {
                return;
            }

            self.FUIFarmlandWindow.m_Grow_CropIcon.url = cropConfig.CropPic;

            int day = GameUtil.GetDaysOfTime(cropConfig.GrowthCycle);
            self.FUIFarmlandWindow.m_GrowText.text = TextHelper.GetGrowUpTimeText(day);
            self.FUIFarmlandWindow.m_Grow_ProductionNum.text = cropConfig.BasicProduction.ToString();
        }
        
        public static void ShowHarvestPanel(this FUIFarmlandWindowComponent self)
        {
            var cropConfig = self.Farmland.Config;
            if (cropConfig == null)
            {
                return;
            }

            self.FUIFarmlandWindow.m_Harvest_CropIcon.url = cropConfig.CropPic;
            self.FUIFarmlandWindow.m_Harvest_ProductionNum.text = cropConfig.BasicProduction.ToString();
            
            if (self.Farmland.PeopleId > 0)
            {
                self.FUIFarmlandWindow.m_hasPeople.selectedIndex = 1;
                
                Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                var peopleComp = unit.GetComponent<PeopleComponent>();
                var people = peopleComp.GetChild<People>(self.Farmland.PeopleId);
                self.FUIFarmlandWindow.m_Harvest_FarmerIconButton.m_Icon.url = PeopleViewHelper.GetHeadIconUrlByGender(people.GetGender());
                self.FUIFarmlandWindow.m_Harvest_FarmerIconButton.m_Name.text = people.Name;
            }
            else
            {
                self.FUIFarmlandWindow.m_hasPeople.selectedIndex = 0;
            }
        }

        public static void OnAddPlantPeopleButtonClick(this FUIFarmlandWindowComponent self)
        {
            self.SelectPlantPeople().Coroutine();
        }

        public static async ETTask SelectPlantPeople(this FUIFarmlandWindowComponent self)
        {
            var selectWorkerWin = FUIComponent.Instance.ShowWindow<FUI_SelectWorkerWindow, FUISelectWorkerWindowComponent>();
            var workers = await selectWorkerWin.ShowAsync(1);
            if (workers.Count <= 0)
            {
                return;
            }

            var workerId = workers[0];
            if (workerId <= 0)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            var worker = peopleComp.GetChild<People>(workerId);
            await FarmlandHelper.GoFarmlandPlant(unit, worker, self.Farmland);
            self.Refresh();
        }

        public static void SelectSeedItem(this FUIFarmlandWindowComponent self, PlantSeedItem plantSeedItem)
        {
            var cropConfig = (CropConfig) plantSeedItem.data;
            self.CurSelectCrop = cropConfig;

            var itemConfig = AllItemConfigCategory.Instance.Get(cropConfig.SeedNeed);
            
            // 获取当前种子的数量
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            var curNum = storeComp.GetItemNum(itemConfig.Id);

            var popup = self.FUIFarmlandWindow.m_SeedInfoPopup;
            popup.m_Name.text = cropConfig.Name;
            
            popup.m_NeedNum.text = $"{curNum}/{cropConfig.SeedNum}";
            string seasonStr = "";
            int[] seasonArray = cropConfig.Season;
            for (int i = 0; i < seasonArray.Length; i++)
            {
                seasonStr += TextHelper.GetSeasonText(seasonArray[i]);
                if (seasonArray.Length > 1 && i < seasonArray.Length - 1)
                {
                    seasonStr += ",";
                }
            }
            popup.m_Season.text = seasonStr;
            popup.m_GrowTime.text = cropConfig.GrowthCycle.ToString();
            popup.Visible = true;
            GRoot.inst.ShowPopup(popup.FGComp, plantSeedItem);
        }

        public static void OnSeedItemClick(this FUIFarmlandWindowComponent self, EventContext context)
        {
            var plantSeedItem = (PlantSeedItem) context.data;
            self.SelectSeedItem(plantSeedItem);
        }

        public static async ETTask OnSeedConfirmButtonClick(this FUIFarmlandWindowComponent self)
        {
            Farmland farmland = self.Building.GetChildByType<Farmland>();
            if (farmland == null)
            {
                Log.Error($"Building [{self.Building.Id}] dosen't have a Farmland");
                return;
            }
           

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            int result = await FarmlandHelper.FarmlandSeed(unit, farmland, self.CurSelectCrop.Id);

            if (result != ErrorCode.ERR_Success)
            {
                return;
            }

            self.SelectPlantPeople().Coroutine();
        }

        public static async ETTask OnGrowSpeedUpButtonClick(this FUIFarmlandWindowComponent self)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            int result = await FarmlandHelper.FarmlandRipe(unit, self.Farmland.Id);
        }

        public static async ETTask SelectHarvestPeople(this FUIFarmlandWindowComponent self)
        {
            var selectWorkerWin = FUIComponent.Instance.ShowWindow<FUI_SelectWorkerWindow, FUISelectWorkerWindowComponent>();
            var workers = await selectWorkerWin.ShowAsync(1);
            if (workers.Count <= 0)
            {
                return;
            }

            var workerId = workers[0];
            if (workerId <= 0)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            var worker = peopleComp.GetChild<People>(workerId);
            await FarmlandHelper.GoFarmlandHarvest(unit, worker, self.Farmland);
            self.Refresh();
        }

        public static void OnHarvestButtonClick(this FUIFarmlandWindowComponent self)
        {
            self.SelectHarvestPeople().Coroutine();
        }

        public static void OnRemoveButtonClick(this FUIFarmlandWindowComponent self)
        {
            if (self.Building == null)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            BuildingHelper.RemoveBuilding(unit, self.Building).Coroutine();
            self.Window.Hide();
        }

        public static void OnHide(this FUIFarmlandWindowComponent self)
        {
            var buildingView = self.Building.GetComponent<BuildingViewComponent>();
            buildingView?.NormalBuilding();
        }

        public static void OnCloseButtonClick(this FUIFarmlandWindowComponent self)
        {
            self.Window.Hide();
        }
    } 
                
}