/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System;
using System.Collections.Generic;
using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIBuilding;
    [Timer(TimerType.UpdateBuildingProgressUITimer)]
    public class UpdateBuildingProgressUITimer : ATimer<FUIPrepareBuildingWindowComponent>
    {
        public override void Run(FUIPrepareBuildingWindowComponent self)
        {
            try
            {
                if (self.IsDisposed || self.Parent == null)
                {
                    return;
                }

                if (self.DomainScene() == null)
                {
                    return;
                }
                
                self.UpdateProgress();
            }
            catch (Exception e)
            {
                Log.Error(e.ToString());
            }
        }
    }
    
    public class FUIPrepareBuildingWindowComponentAwakeSystem : AwakeSystem<FUIPrepareBuildingWindowComponent>
    {
        public override void Awake(FUIPrepareBuildingWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(Construct))]
    public static partial class FUIPrepareBuildingWindowComponentSystem
    {
        public static void Awake(this FUIPrepareBuildingWindowComponent self)
        {
            self.FUIPrepareBuildingWindow = self.Parent.GetComponent<FUI_PrepareBuildingWindow>();

            var win = new FUIPrepareBuildingWindow();
            win.OnWindowShow = self.OnWindowShow;
            win.OnWindowHide = self.OnWindowHide;
            self.Window = win;
            self.Window.contentPane = self.FUIPrepareBuildingWindow.FGComp;
            
         
            // init event
            self.FUIPrepareBuildingWindow.m_AddSpeedButton.FGComp.onClick.Add(self.OnAddSpeedButtonClick);
            self.FUIPrepareBuildingWindow.m_CompleteButton.FGComp.AddClickListenerAsync(self.OnCompleteButtonClick);
            self.FUIPrepareBuildingWindow.m_CancelBuildingButton.FGComp.AddClickListenerAsync(self.OnCancelBuildingButtonClick);
        }

        public static void OnWindowShow(this FUIPrepareBuildingWindowComponent self)
        {
            
        }

        public static void OnWindowHide(this FUIPrepareBuildingWindowComponent self)
        {
            TimerComponent.Instance.Remove(ref self.UpdateTimer);
        }

        public static void ShowInfo(this FUIPrepareBuildingWindowComponent self, Construct construct)
        {
            self.Construct = construct;
            var synConfig = SynthesisConfigCategory.Instance.Get(construct.ConfigId);
            var buildingConfig = StructureConfigCategory.Instance.Get(synConfig.MixtureID);
            string iconUrl = $"{buildingConfig.Picture}";
            self.FUIPrepareBuildingWindow.m_BuildingName.text = buildingConfig.Name;
            self.FUIPrepareBuildingWindow.m_BuildingIcon.url = iconUrl;
            
            
            var list = self.FUIPrepareBuildingWindow.m_PrepareWorkerList;
            var count = list.numChildren;
            
            for (int i = 0; i < count; i++)
            {
                PrepareWorkerItem item = (PrepareWorkerItem)list.GetChildAt(i);
                item.SetHasPeople(false);
                // worker
                item.AddWorkerButton.onClick.Remove(self.OnAddWorkerButtonClick);
                item.AddWorkerButton.onClick.Add(self.OnAddWorkerButtonClick);

                // cancel button
                item.CancelButton.data = item;
                item.CancelButton.AddClickListenerAsync(self.OnWorkerCancelButtonClick);
            }

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            int peopleIdx = 0;
            List<long> workPeopleList = new List<long>();
            workPeopleList.AddRange(construct.PeopleIdList);
            workPeopleList.AddRange(construct.PreparePeopleIdList);
            foreach (var id in workPeopleList)
            {
                PrepareWorkerItem item = (PrepareWorkerItem)list.GetChildAt(peopleIdx);
                People p = peopleComp.GetChild<People>(id);
                
                item.SetIcon(PeopleViewHelper.GetHeadIconUrlByGender(p.GetGender()));
                item.SetHasPeople(true);
                item.data = p;
                peopleIdx++;
            }

            self.UpdateProgress();
            TimerComponent.Instance.Remove(ref self.UpdateTimer);
            self.UpdateTimer = TimerComponent.Instance.NewRepeatedTimer(1000, TimerType.UpdateBuildingProgressUITimer, self);
        }

        public static void UpdateProgress(this FUIPrepareBuildingWindowComponent self)
        {
            var construct = self.Construct;
            if (construct.IsDisposed)
            {
                return;
            }
            var synConfig = SynthesisConfigCategory.Instance.Get(construct.ConfigId);
            self.FUIPrepareBuildingWindow.m_DurabilityLabel.text = $"{construct.Progress}/{synConfig.BodyVolume}";
            var bar = self.FUIPrepareBuildingWindow.m_DurabilityProgressBar.FGComp;
            bar.max = synConfig.BodyVolume;
            bar.value = construct.Progress;

            if (construct.PeopleIdList.Count > 0)
            {
                var labor = construct.GetLaborSpeed();
                self.FUIPrepareBuildingWindow.m_Labour.text = labor.ToString();
                var leftTime = (float) (synConfig.BodyVolume - construct.Progress) / labor * 5; // 因为每5s结算一次
                self.FUIPrepareBuildingWindow.m_LeftTime.text = Mathf.RoundToInt(leftTime) + "s";
            }
            else
            {
                self.FUIPrepareBuildingWindow.m_Labour.text = "--";
                self.FUIPrepareBuildingWindow.m_LeftTime.text = "--:--";
            }
         
        }

        public static void OnAddSpeedButtonClick(this FUIPrepareBuildingWindowComponent self)
        {
            Log.Debug("AddSpeed Button Click");
        }

        public static async ETTask OnCompleteButtonClick(this FUIPrepareBuildingWindowComponent self)
        {
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            await ConstructHelper.ConstructFinish(unit, self.Construct.Id);
            Log.Debug("Complete Button Click");
        }

        public static async ETTask OnCancelBuildingButtonClick(this FUIPrepareBuildingWindowComponent self)
        {
            var idEnum = TextConfigEnum.ID_1033;
            if (self.Construct.IsConstructed > 0)
            {
                idEnum = TextConfigEnum.ID_1034;
            }

            var result = await CommonHelper.ShowMessageAsync(self.ZoneScene(), idEnum);

            if (result == MessageBoxResult.Confirm)
            {
                Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                await ConstructHelper.CancelConstruct(unit, self.Construct.Id);
            
                self.Window.Hide();   
            }
        }

        public static void OnAddWorkerButtonClick(this FUIPrepareBuildingWindowComponent self, EventContext context)
        {
            var fuiComponent = self.ZoneScene().GetComponent<FUIComponent>();
            var workerSelectWindow = fuiComponent.ShowWindow<FUI_BuildingSelectWorkerWindow, FUIBuildingSelectWorkerWindowComponent>();
            workerSelectWindow.ShowInfo(self.Construct);
        }


        public static async ETTask OnWorkerCancelButtonClick(this FUIPrepareBuildingWindowComponent self, EventContext context)
        {
            GObject sender = context.sender as GObject;
            PrepareWorkerItem item = (PrepareWorkerItem) sender.data;
            item.SetHasPeople(false);

            People p = (People) item.data;
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            await ConstructHelper.StopConstruct(unit, self.Construct.Id, p.Id);
            self.ShowInfo(self.Construct);
        }
    } 
                
}