﻿using ET.EventType;
using ET.FUIBuilding;

namespace ET
{
    public class FarmlandStateChanged_RefreshWindow : AEvent<FarmlandStateChanged>
    {
        protected override void Run(FarmlandStateChanged args)
        {
            var winEntity = FUIComponent.Instance.GetWindow(FUI_FarmlandWindow.UIResName);
            if (winEntity != null)
            {
                var farmlandWin = winEntity as FUIFarmlandWindowComponent;
                if (farmlandWin.IsShowing)
                {
                    farmlandWin.CheckToRefresh(args.Farmland);
                    return;
                }
            }
            
            winEntity = FUIComponent.Instance.GetWindow(FUI_FarmlandBatchWindow.UIResName);
            if (winEntity != null)
            {
                var farmlandWin = winEntity as FUIFarmlandBatchWindowComponent;
                if (farmlandWin.IsShowing)
                {
                    farmlandWin.CheckToRefresh(args.Farmland);
                    return;
                }
            }
        }
    }
}