﻿namespace ET
{
    using FairyGUI;
    using FUICommon;
    using System;

    public static class CommonHelper
    {    
        public static void ShowHint(Scene scene, string text)
        {
            var win = scene.GetComponent<FUIComponent>().ShowWindow<FUI_CommonHintWindow, FUICommonHintWindowComponent>();
            var com = win.Get();
            com.Show(text);
        }

        public static void ShowHint(Scene scene, int id)
        {
            var win = scene.GetComponent<FUIComponent>().ShowWindow<FUI_CommonHintWindow, FUICommonHintWindowComponent>();
            var com = win.Get();
            com.Show(id);
        }

        public static void ShowHint(Scene scene, TextConfigEnum idEnum)
        {
            ShowHint(scene, (int)idEnum);
        }

        public static void ShowMessage(Scene scene, int textId, int messageType = 0, Action ConfirmCallback = null, Action CancelCallback = null)
        {
            var com = scene.GetComponent<FUIComponent>().ShowWindow<FUI_CommonConfirmWindow, FUICommonConfirmWindowComponent>();
            com.Show(textId, messageType, ConfirmCallback, CancelCallback);
        }

        public static void ShowMessage(Scene scene, string text, int messageType = 0, Action ConfirmCallback = null, Action CancelCallback = null)
        {
            var com = scene.GetComponent<FUIComponent>().ShowWindow<FUI_CommonConfirmWindow, FUICommonConfirmWindowComponent>();
            com.Show(text, messageType, ConfirmCallback, CancelCallback);
        }

        /// <summary>
        /// 异步显示消息框
        /// </summary>
        /// <param name="scene"></param>
        /// <param name="idEnum">消息文本的Id枚举</param>
        /// <param name="messageType">消息框类型</param>
        /// <returns></returns>
        public static ETTask<MessageBoxResult> ShowMessageAsync(Scene scene, TextConfigEnum idEnum, MessageBoxType messageType = 0)
        {
            var com = scene.GetComponent<FUIComponent>().ShowWindow<FUI_CommonConfirmWindow, FUICommonConfirmWindowComponent>();
            return com.ShowAsync((int)idEnum, messageType);
        }
    }
}
