﻿using ET.EventType;

namespace ET
{
    using FUICuisine;
    
    [FriendClass(typeof(Menu))]
    public class CookingFinish : AEvent<EventType.CookingFinish>
    {
        protected override void Run(EventType.CookingFinish args)
        {
            Unit unit = args.Unit;
            FUIComponent fuiCom = unit.ZoneScene().GetComponent<FUIComponent>();
            var win = fuiCom.GetWindow(FUI_CuisineWindow.UIResName) as FUICuisineWindowComponent;
            if (win.IsShowing)
            {
                int synthesisID = SynthesisConfigCategory.Instance.GetSynthesisIDByMixtureID(args.MixtureID);
                if (synthesisID == 0 || args.MixtureID == 3001)
                {
                    if(args.SelectedCuisine == 0)
                    {
                        CommonHelper.ShowHint(unit.ZoneScene(), "研发失败");
                    }
                    else
                    {
                        CommonHelper.ShowHint(unit.ZoneScene(), "制作失败");
                    }
                }
                else
                {
                    if (MenuExist(unit, synthesisID))
                    {
                        CommonHelper.ShowHint(unit.ZoneScene(), "制作成功");
                    }
                    else
                    {
                        CommonHelper.ShowHint(unit.ZoneScene(), "研发成功");
                    }
                }
            }
        }

        private bool MenuExist(Unit unit, int synthesisID)
        {
            MenuComponent mc = unit.GetComponent<MenuComponent>();
            foreach (Menu menu in mc.Children.Values)
            {
                if (menu.ConfigId == synthesisID) return true;
            }
            return false;
        }
    }
}
