/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using FairyGUI;
namespace ET
{
    using FUICuisine;
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using UnityEngine;

    [Timer(TimerType.UpdateCookingFireProgressTimer)]
    public class UpdateCookingFireProgressTimer : ATimer<FUICuisineWindowComponent>
    {
        public override void Run(FUICuisineWindowComponent self)
        {
            try
            {
                if (self.IsDisposed || self.Parent == null) return;
                if (self.DomainScene() == null) return;

                self.UpdateFireProgress();
            }
            catch (Exception ex)
            {
                Log.Error(ex.ToString());
            }
        }
    }

    [Timer(TimerType.UpdateCookingProgressTimer)]
    public class UpdateCookingProgressTimer : ATimer<FUICuisineWindowComponent>
    {
        public override void Run(FUICuisineWindowComponent self)
        {
            try
            {
                if (self.IsDisposed || self.Parent == null) return;
                if (self.DomainScene() == null) return;

                self.UpdateCookingProgress();
            }
            catch (Exception ex)
            {
                Log.Error(ex.ToString());
            }
        }
    }
    
    public class FUICuisineWindowComponentAwakeSystem : AwakeSystem<FUICuisineWindowComponent>
    {
        public override void Awake(FUICuisineWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(Menu))]
    [FriendClass(typeof(Item))]
    [FriendClass(typeof(FUI_CookingSlider))]
    public static partial class FUICuisineWindowComponentSystem
    {
        public static void Awake(this FUICuisineWindowComponent self)
        {
            self.FUICuisineWindow = self.Parent.GetComponent<FUI_CuisineWindow>();
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Cuisine_CuisineTypeTab, typeof(CuisineTab));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Cuisine_CuisineTreeItem1, typeof(CuisineTreeItem1));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Cuisine_CuisineTreeItem2, typeof(CuisineTreeItem2));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Cuisine_MaterialInfoItem, typeof(MaterialInfoItem));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Cuisine_FoodItem, typeof(FoodItem));

            FUICuisineWindow win = new FUICuisineWindow();
            win.OnWindowShow = self.OnWindowShow;
            win.OnWindowHide = self.OnWindowHide;
            self.Window = win;
            self.Window.contentPane = self.FUICuisineWindow.FGComp;
            //ñǩҳĵ¼
            int tabNum = self.FUICuisineWindow.m_CuisineTypeTab.numItems;
            if (tabNum > 0)
            {
                for(int i = 0; i < tabNum; i++)
                {
                    var tab = self.FUICuisineWindow.m_CuisineTypeTab.GetChildAt(i).asButton;
                    if (tab != null)
                    {
                        tab.data = i + 1;
                        tab.onClick.Remove(self.OnTabClickEvent);
                        tab.onClick.Add(self.OnTabClickEvent);
                    }
                }
            }
            //ôڹر
            self.FUICuisineWindow.m_ExitButton.FGComp.onClick.Set(win.Hide);
            //鰴ť
            self.FUICuisineWindow.m_BuildingInfoButton.FGComp.onClick.Set(self.OpenBuildingInfo);
            //ť
            self.FUICuisineWindow.m_CookingButton.FGComp.onClick.Set(self.OnCookingBtnClick);
            self.FUICuisineWindow.m_BatchCookingButton.FGComp.onClick.Set(self.OnBatchingCookingBtnClick);
            self.FUICuisineWindow.m_FanButton.FGComp.onClick.Set(self.OnFanBtnClick);
            self.FUICuisineWindow.m_BuildingInfoButton.FGComp.onClick.Set(self.OpenBuildingInfo);
            //ʳλ¼
            self.FUICuisineWindow.m_Slot1.FGComp.data = 0;
            self.FUICuisineWindow.m_Slot1.FGComp.onClick.Set(self.OpenMaterialInfo);
            self.FUICuisineWindow.m_Slot2.FGComp.data = 1;
            self.FUICuisineWindow.m_Slot2.FGComp.onClick.Set(self.OpenMaterialInfo);
            self.FUICuisineWindow.m_Slot3.FGComp.data = 2;
            self.FUICuisineWindow.m_Slot3.FGComp.onClick.Set(self.OpenMaterialInfo);
        }

        public static void OnWindowShow(this FUICuisineWindowComponent self)
        {
            self.ZoneScene().GetComponent<FUIPackageComponent>().AddPackage("AllItem");
            self.foodSelectedList.Clear();
        }

        public static void OnWindowHide(this FUICuisineWindowComponent self)
        {
            self.selectedCuisine = 0;
            self.CurrentBuilding = null;
            self.cuisineTreeItem2 = null;
            self.UnlockedCuisine.Clear();
            TimerComponent.Instance.Remove(ref self.UpdateFireTimer);
            TimerComponent.Instance.Remove(ref self.UpdateCookingTimer);
        }

        public static async ETTask ShowInfoAsync(this FUICuisineWindowComponent self, Building building)
        {
            self.CurrentBuilding = building;
            self.FUICuisineWindow.m_CuisineTypeTab.selectedIndex = 0;
            self.FireEdgeSmall = WorldParametersConfigCategory.Instance.Get(WorldParam.HeatingRatio).Value[0];
            self.FireEdgeMiddle = WorldParametersConfigCategory.Instance.Get(WorldParam.HeatingRatio).Value[1];
            self.FireEdgeGreat = WorldParametersConfigCategory.Instance.Get(WorldParam.HeatingRatio).Value[2];
            await self.GetFoodMaterialList();
            await self.GetUnlockCuisineList();
            self.RefreshFoodSlot();
        }

        private static void OnTabClickEvent(this FUICuisineWindowComponent self, EventContext context)
        {
            GButton tab = context.sender as GButton;
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            Log.Debug($"Ʒ: {(int)tab.data}");
            self.UnlockedCuisine = MenuHelper.GetUnlockedMenuWithType(unit, (int)tab.data);
            self.selectedCuisine = 0;
            self.GetUnlockCuisineList().Coroutine();
        }

        private static void OpenBuildingInfo(this FUICuisineWindowComponent self)
        {
            self.Window.Hide();
            if (self.CurrentBuilding == null) return;
            var buildingInfoWindowComp = self.ZoneScene().GetComponent<FUIComponent>().ShowWindow<FUIBuilding.FUI_BuildingInfoWindow, FUIBuildingInfoWindowComponent>();
            buildingInfoWindowComp.ShowInfo(self.CurrentBuilding);
        }

        public static async ETTask GetUnlockCuisineList(this FUICuisineWindowComponent self)
        {
            //TODO - ҪͷȷϵǰĲϢ 
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            await MenuHelper.GetMenu(unit);
            self.UnlockedCuisine = MenuHelper.GetUnlockedMenuWithType(unit, self.FUICuisineWindow.m_CuisineTypeTab.selectedIndex + 1);
            self.CuisineItemRender();
            //int defaultCuisine = 0;
            //if(self.selectedCuisine == 0 && self.UnlockedCuisine.Count > 0)
            //{
            //    defaultCuisine = self.UnlockedCuisine[0].ConfigId;
            //}
            self.RefreshCuisineListDisplay(0);
        }

        private static Menu GetMenu(this FUICuisineWindowComponent self, int id)
        {
            Menu result = null;
            foreach(var menu in self.UnlockedCuisine)
            {
                if(menu.ConfigId == id)
                {
                    result = menu;
                }
            }
            return result;
        }

        public static async ETTask GetFoodMaterialList(this FUICuisineWindowComponent self)
        {
            //TODO - ҪͷȷϵǰֿʳĿ
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            //ˢ²ֿ
            await StoreHelper.GetStore(unit);
            var sc = unit.GetComponent<StoreComponent>();
            //ʳ
            var fms = sc.GetItemsWithType(1, 3);
            fms.Sort((a, b) => {
                AllItemConfig aCfg = AllItemConfigCategory.Instance.Get(a.ConfigId);
                AllItemConfig bCfg = AllItemConfigCategory.Instance.Get(b.ConfigId);
                return -aCfg.Grade.CompareTo(bCfg.Grade) * 2 - aCfg.Id.CompareTo(bCfg.Id);
            });

            var foodList = self.FUICuisineWindow.m_FMList;
            foodList.RemoveChildrenToPool();
            for(int i = 0; i < fms.Count; i++)
            {
                FoodItem item = (FoodItem)foodList.AddItemFromPool();
                AllItemConfig itemInfo = AllItemConfigCategory.Instance.Get(fms[i].ConfigId);
                item.SetIcon(itemInfo.Icon);
                item.SetNum(sc.GetItemNum(itemInfo.Id));
                item.data = fms[i].ConfigId;
                item.onClick.Remove(self.OnFoodMaterialClick);
                item.onClick.Add(self.OnFoodMaterialClick);
            }
        }

        private static void OnFoodMaterialClick(this FUICuisineWindowComponent self, EventContext context)
        {
            GButton button = (GButton)context.sender;
            if(self.selectedCuisine != 0)
            {
                CommonHelper.ShowHint(self.ZoneScene(), 1022);
                return;
            }
            int id = (int)button.data;
            Log.Debug($"ѡ:{id}");
            //ѡеб״̬
            if (!self.foodSelectedList.Contains(id))
            {
                if(self.foodSelectedList.Count >= 3)
                {
                    CommonHelper.ShowHint(self.ZoneScene(), 1017);
                    return;
                }
                self.foodSelectedList.Add(id);
            }
            else
            {
                self.foodSelectedList.Remove(id);
            }
            self.FUICuisineWindow.m_CookingButton.Visible = self.foodSelectedList.Count > 0;
            self.RefreshFoodSlot();
            self.RefreshFoodSelected();
        }

        private static void RefreshFoodSelected(this FUICuisineWindowComponent self)
        {
            for(int i = 0; i < self.FUICuisineWindow.m_FMList.numChildren; i++)
            {
                var item = (FoodItem)self.FUICuisineWindow.m_FMList.GetChildAt(i);
                var cfgID = (int)item.data;
                item.GetController("IsSelected").selectedIndex = self.foodSelectedList.Contains(cfgID) ? 1 : 0;
            }
        }

        private static string GetListItemResource(int treeItemType)
        {
            string result;
            switch (treeItemType % 2)
            {
                case 0:
                    {
                        result = FUIPackage.Cuisine_CuisineTreeItem1;
                    }
                    break;
                case 1:
                    {
                        result = FUIPackage.Cuisine_CuisineTreeItem2;
                    }
                    break;
                default:
                    result = FUIPackage.Cuisine_CuisineTreeItem1;
                    break;
            }
            return result;
        }

        private static void CuisineItemRender(this FUICuisineWindowComponent self)
        {
            var list = self.FUICuisineWindow.m_CuisineList;
            list.RemoveChildren();
            self.cuisineTreeItem2 = null;
            for (int i = 0; i < self.UnlockedCuisine.Count; i++)
            {
                int SynthesisID = self.UnlockedCuisine[i].ConfigId;
                SynthesisConfig synCfg = SynthesisConfigCategory.Instance.Get(SynthesisID);
                AllItemConfig itemCfg = AllItemConfigCategory.Instance.Get(synCfg.MixtureID);
                CuisineTreeItem1 item1 = (CuisineTreeItem1)list.AddItemFromPool(GetListItemResource(0));
                CuisineConfig cuiCfg = CuisineConfigCategory.Instance.Get(itemCfg.RelatedId);
                item1.data = SynthesisID;
                item1.SetIcon(itemCfg.Icon);
                item1.SetName(itemCfg.Name);
                item1.SetNutrition(cuiCfg.NutritiveValue);
                Menu menu = self.GetMenu(SynthesisID);
                item1.SetMastery(menu == null ? 0 : menu.Proficiency);
                int waterIndex = synCfg.ItemId.ToList().IndexOf(1003);
                if (waterIndex != -1)
                {
                    item1.SetWaterCost(synCfg.ItemNum[waterIndex]);
                }
                item1.onClick.Remove(self.OnCuisineClick);
                item1.onClick.Add(self.OnCuisineClick);
            }
        }

        private static void RefreshFoodSlot(this FUICuisineWindowComponent self)
        {
            GLoader slot1 =self.FUICuisineWindow.m_Slot1.m_Icon;
            GLoader slot2 =self.FUICuisineWindow.m_Slot2.m_Icon;
            GLoader slot3 =self.FUICuisineWindow.m_Slot3.m_Icon;
            slot1.url = slot2.url = slot3.url = null;
            for (int i = 0; i < self.foodSelectedList.Count; i++)
            {
                string icon = AllItemConfigCategory.Instance.Get(self.foodSelectedList[i]).Icon;
                switch (i)
                {
                    case 0:
                        slot1.url = $"ui://AllItem/{icon}";
                        break;
                    case 1:
                        slot2.url = $"ui://AllItem/{icon}";
                        break;
                    case 2:
                        slot3.url = $"ui://AllItem/{icon}";
                        break;
                }
            }
        }

        private static void OnCuisineClick(this FUICuisineWindowComponent self, EventContext context)
        {
            CuisineTreeItem1 item1 = context.sender as CuisineTreeItem1;
            var list = self.FUICuisineWindow.m_CuisineList;
            int index = list.GetChildIndex(item1);
            if (index == -1) return;
            int SynthesisID = (int)item1.data;
            self.RefreshCuisineListDisplay(SynthesisID);
            //ʱ
            if (self.cuisineTreeItem2 == null) return;
            list.SetChildIndex(self.cuisineTreeItem2, index + 1);
        }

        private static void RefreshCuisineListDisplay(this FUICuisineWindowComponent self, int SynthesisID)
        {
            EventCallback1 OpenMaterialInfo = (c) => {
                MaterialInfoItem button = c.sender as MaterialInfoItem;
                int materialId = (int)button.data;
                Log.Debug($":{materialId}");
                var fuiComponent = self.ZoneScene().GetComponent<FUIComponent>();
                CommonHelper.ShowHint(self.ZoneScene(), $":{materialId}");
                //TODO - ʾ
                //Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                //var storeComp = unit.GetComponent<StoreComponent>();
                //
                //// ȡ߱Ϣ
                //var itemConfig = AllItemConfigCategory.Instance.Get(materialId);
                //var popUpCom = self.FUISynthesisWindow.m_SynthesisItemInfoPopup;
                //popUpCom.m_Name.text = itemConfig.Name;
                //popUpCom.m_Type.text = itemConfig.RelatedTable.ToString();
                //popUpCom.m_Owned.SetVar("num", storeComp.GetItemNum(materialId).ToString()).FlushVars();
                //popUpCom.m_Price.SetVar("num", itemConfig.SellPrice.ToString()).FlushVars();
                //popUpCom.m_ItemDescription.text = itemConfig.Description;
                //popUpCom.m_ItemSource.text = itemConfig.GetMethod;
                //popUpCom.FGComp.visible = true;
                //
                //GRoot.inst.ShowPopup(self.FUISynthesisWindow.m_SynthesisItemInfoPopup.FGComp, button);
            };

            var list = self.FUICuisineWindow.m_CuisineList;
            Log.Debug($"selectedCuisine: {self.selectedCuisine} SynthesisID: {SynthesisID}");
            //жϵǰѡĲ
            if (self.selectedCuisine == SynthesisID)
            {
                Log.Debug($"selectedCuisine1");
                self.selectedCuisine = 0;
                self.foodSelectedList.Clear();
                self.RefreshFoodSlot();
                self.RefreshFoodSelected();
                if (self.cuisineTreeItem2 != null)
                {
                    self.cuisineTreeItem2.selected = false;
                    list.RemoveChildToPool(self.cuisineTreeItem2);
                    self.cuisineTreeItem2 = null;
                }
                self.FUICuisineWindow.m_CookingButton.Visible = self.foodSelectedList.Count > 0;
                self.FUICuisineWindow.m_BatchCooking.selectedIndex = 0;
            }
            else
            {
                Log.Debug($"selectedCuisine2");
                SynthesisConfig synCfg = SynthesisConfigCategory.Instance.Get(SynthesisID);
                Menu menu = self.GetMenu(SynthesisID);
                AllItemConfig itemCfg = AllItemConfigCategory.Instance.Get(synCfg.MixtureID);
                self.selectedCuisine = SynthesisID;
                self.foodSelectedList.Clear();
                var tempList = synCfg.ItemId.ToList();
                //Ƴˮ
                tempList.Remove(1003);
                self.foodSelectedList.AddRange(tempList);
                self.RefreshFoodSlot();
                self.RefreshFoodSelected();
                self.cuisineTreeItem2 = self.cuisineTreeItem2 == null ? (CuisineTreeItem2)list.AddItemFromPool(GetListItemResource(1)) : self.cuisineTreeItem2;
                self.cuisineTreeItem2.selected = true;
                self.cuisineTreeItem2.MaterialList.RemoveChildrenToPool();
                self.cuisineTreeItem2.SetDescription(itemCfg.Description);
                Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
                var sc = unit.GetComponent<StoreComponent>();
                bool allMatReady = true;
                for (int j = 0; j < synCfg.ItemId.Length; j++)
                {
                    int subMatId = synCfg.ItemId[j];
                    if (subMatId == 1003) continue;
                    int subMatRequire = synCfg.ItemNum[j];
                    MaterialInfoItem materialInfoItem = (MaterialInfoItem)self.cuisineTreeItem2.MaterialList.AddItemFromPool();
                    var subItemConfig = AllItemConfigCategory.Instance.Get(subMatId);
                    materialInfoItem.data = subMatId;
                    materialInfoItem.SetIcon(subItemConfig.Icon);
                    long ownedNum = sc.GetItemNum(subMatId);
                    if (ownedNum < subMatRequire) allMatReady = false;
                    materialInfoItem.SetAmount(ownedNum, subMatRequire);
                    materialInfoItem.onClick.Remove(OpenMaterialInfo);
                    materialInfoItem.onClick.Add(OpenMaterialInfo);
                }
                //׼ʱŸ밴ťʾ
                self.FUICuisineWindow.m_CookingButton.Visible = allMatReady;
                self.FUICuisineWindow.m_BatchCookingButton.Visible = allMatReady;
                self.FUICuisineWindow.m_BatchCooking.selectedIndex = menu.Proficiency >= synCfg.NeedProficiency ? 1 : 0;
            }
        }

        private static async void OnCookingBtnClick(this FUICuisineWindowComponent self, EventContext context)
        {
            //TODO - Ϸʼ
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            if (self.foodSelectedList.Count <= 0) return;
            //ж
            if(self.selectedCuisine != 0 &&!self.BuildingCheck(self.selectedCuisine))
            {
                CommonHelper.ShowHint(self.ZoneScene(), 1015);
                return;
            }
            var result = await CuisineHelper.DevelopRecipes(unit, self.foodSelectedList.ToArray());
            if(result == ErrorCode.ERR_Success)
            {
                Log.Debug($"ʼɹ");
            }
            else
            {
                Log.Debug($"ʼʧ: {result}");
            }
        }

        private static bool BuildingCheck(this FUICuisineWindowComponent self, int synthesisId)
        {
            if (synthesisId == 0) return false;
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            SynthesisConfig config = SynthesisConfigCategory.Instance.Get(synthesisId);
            return ConstructOperate.CheckOutBuildingByIds(unit, config.StructureID);
        }

        private static void OnBatchingCookingBtnClick(this FUICuisineWindowComponent self, EventContext context)
        {
            if (self.selectedCuisine == 0) return;
            GButton button = context.sender as GButton;

            SynthesisConfig synthesisConfig = SynthesisConfigCategory.Instance.Get(self.selectedCuisine);
            // ȡ߱Ϣ
            AllItemConfig itemConfig = AllItemConfigCategory.Instance.Get(synthesisConfig.MixtureID);

            var popUpCom = self.FUICuisineWindow.m_BatchCookingPopup;
            popUpCom.m_Name.text = synthesisConfig.Name;
            popUpCom.m_Description.text = itemConfig.Description;
            popUpCom.m_Icon.url = $"ui://AllItem/{itemConfig.Icon}";
            popUpCom.FGComp.visible = true;

            var slider = popUpCom.m_CookingSlider.FGComp;
            //òʾ
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var sc = unit.GetComponent<StoreComponent>();
            int maxMakableNum = 999;
            popUpCom.m_MaterialList.RemoveChildrenToPool();
            for (int j = 0; j < synthesisConfig.ItemId.Length; j++)
            {
                int subMatId = synthesisConfig.ItemId[j];
                int subMatRequire = synthesisConfig.ItemNum[j];
                MaterialInfoItem materialInfoItem = (MaterialInfoItem)popUpCom.m_MaterialList.AddItemFromPool();
                var subItemConfig = AllItemConfigCategory.Instance.Get(subMatId);
                materialInfoItem.data = subMatId;
                materialInfoItem.SetIcon(subItemConfig.Icon);
                long ownedNum = subMatId == 1003 ? unit.Water : sc.GetItemNum(subMatId);
                int makableNum = (int)(ownedNum / subMatRequire);
                maxMakableNum = Math.Min(maxMakableNum, makableNum);
                materialInfoItem.SetAmount(ownedNum, subMatRequire);
                materialInfoItem.onClick.Remove(self.OpenMaterialInfo);
                materialInfoItem.onClick.Add(self.OpenMaterialInfo);
            }
            //û
            slider.max = maxMakableNum;
            slider.value = Math.Min(maxMakableNum, 1);
            popUpCom.m_PgsText.SetVar("curNum", slider.value.ToString()).SetVar("totalNum", maxMakableNum.ToString()).FlushVars();
            slider.onChanged.Clear();

            EventCallback0 refresh = () => {
                int maxNum = 999;
                string sv = double.IsNaN(slider.value) ? "0" : slider.value.ToString();
                for (int j = 0; j < synthesisConfig.ItemId.Length; j++)
                {
                    int subMatId = synthesisConfig.ItemId[j];
                    int subMatRequire = synthesisConfig.ItemNum[j];
                    MaterialInfoItem materialInfoItem = (MaterialInfoItem)popUpCom.m_MaterialList.GetChildAt(j);
                    var subItemConfig = AllItemConfigCategory.Instance.Get(subMatId);
                    long ownedNum = subMatId == 1003 ? unit.Water : sc.GetItemNum(subMatId);
                    int makableNum = (int)(ownedNum / subMatRequire);
                    maxNum = Math.Min(maxNum, makableNum);
                    materialInfoItem.SetAmount(ownedNum, subMatRequire * Math.Max(int.Parse(sv), 1));
                }
                popUpCom.m_PgsText.SetVar("curNum", sv).SetVar("totalNum", maxNum.ToString()).FlushVars();
            };
            slider.onChanged.Add(refresh);

            popUpCom.m_PlusButton.FGComp.onClick.Clear();
            popUpCom.m_PlusButton.FGComp.onClick.Add(() => {
                slider.value = Math.Clamp(slider.value + 1, 0, slider.max);
                refresh();
            });

            popUpCom.m_MinusButton.FGComp.onClick.Clear();
            popUpCom.m_MinusButton.FGComp.onClick.Add(() => {
                slider.value = Math.Clamp(slider.value - 1, 0, slider.max); ;
                refresh();
            });
            //ť¼
            popUpCom.m_confirmBtn.FGComp.onClick.Add(() => {
                if (self.selectedCuisine != 0 && !self.BuildingCheck(self.selectedCuisine))
                {
                    CommonHelper.ShowHint(self.ZoneScene(), 1015);
                    return;
                }
                Log.Debug($"׼");
                CuisineHelper.StartCuisine(unit, self.selectedCuisine, (long)slider.value).Coroutine();
            });

            GRoot.inst.ShowPopup(popUpCom.FGComp, button);
        }

        public static void CookingGameReady(this FUICuisineWindowComponent self, int synthesisID)
        {
            self.FUICuisineWindow.m_IsGaming.selectedIndex = 1;
            self.CurCookingCuisine = synthesisID;
            self.FireConditionMistakeMax = WorldParametersConfigCategory.Instance.Get(WorldParam.HeatcontrolLimit).Value[0];
            self.mistakeTimeSum = 0;
            self.fireTimeSum = 0;
            self.FireConditionMistakeCur = 0;
            //û
            self.FUICuisineWindow.m_FireProgress.FGComp.max = WorldParametersConfigCategory.Instance.Get(WorldParam.HeatingProgress).Value[0];
            self.HeatDown = WorldParametersConfigCategory.Instance.Get(WorldParam.HeatingDown).Value[0] / 200.00f;
            self.CurFirePgs = self.TarFirePgs = 0;
            TimerComponent.Instance.Remove(ref self.UpdateFireTimer);
            self.UpdateFireTimer = TimerComponent.Instance.NewRepeatedTimer(5, TimerType.UpdateCookingFireProgressTimer, self);
            //СϷ
            self.FUICuisineWindow.m_CookingPgs.FGComp.max = 3;
            self.FUICuisineWindow.m_CookingPgs.FGComp.value = 0;
            //ֶȥ
            int compare1; int compare2; int compare3;
            if (synthesisID != 0)
            {
                SynthesisConfig synthesisConfig = SynthesisConfigCategory.Instance.Get(synthesisID);
                self.CurFireRequire = synthesisConfig.FactorDemand[0];
                self.AllFireRequire = synthesisConfig.FactorDemand.ToList();
                compare1 = synthesisConfig.FactorDemand[0];
                compare2 = synthesisConfig.FactorDemand[1];
                compare3 = synthesisConfig.FactorDemand[2];
            }
            else
            {
                //
                List<int> radFire = new List<int>(); 
                for(int i = 0; i < 3; i++)
                {
                    radFire.Add(UnityEngine.Random.Range(1, 4));
                }
                self.CurFireRequire = radFire[0];
                self.AllFireRequire = radFire;
                compare1 = radFire[0];
                compare2 = radFire[1];
                compare3 = radFire[2];
            }
            self.FUICuisineWindow.m_Stage1Txt.text = ((FireCondition)compare1).ToString();
            self.FUICuisineWindow.m_Stage2Txt.text = ((FireCondition)compare2).ToString();
            self.FUICuisineWindow.m_Stage3Txt.text = ((FireCondition)compare3).ToString();
            if (compare1 == compare2)
            {
                //ֻʣ211
                self.FUICuisineWindow.m_HeatHint.selectedIndex = compare2 == compare3 ? 3 : 1;
            }
            else
            {
                //ֻʣ12111
                self.FUICuisineWindow.m_HeatHint.selectedIndex = compare2 == compare3 ? 2 : 0;
            }
          
            self.gamePgs = 0;
            TimerComponent.Instance.Remove(ref self.UpdateCookingTimer);
            self.UpdateCookingTimer = TimerComponent.Instance.NewRepeatedTimer(10000, TimerType.UpdateCookingProgressTimer, self);
        }

        private static void OnFanBtnClick(this FUICuisineWindowComponent self, EventContext context)
        {
            if(self.FUICuisineWindow.m_IsGaming.selectedIndex == 0)
            {
                //var fuiComponent = self.ZoneScene().GetComponent<FUIComponent>();
                //fuiComponent.Get().Show(TextConfigCategory.Instance.Get(1018).Text);
                CommonHelper.ShowHint(self.ZoneScene(), 1018);
                return;
            }
            var pgs = self.FUICuisineWindow.m_FireProgress.FGComp;
            int HeatUp = WorldParametersConfigCategory.Instance.Get(WorldParam.HeatingUp).Value[0];
            self.TarFirePgs = Math.Clamp(self.TarFirePgs + HeatUp, 0, (int)pgs.max);
        }

        //ˢ¼ʱ
        public static void UpdateFireProgress(this FUICuisineWindowComponent self)
        {
            var pgs = self.FUICuisineWindow.m_FireProgress.FGComp;
            self.TarFirePgs = Math.Clamp(self.TarFirePgs - self.HeatDown, 0, (int)pgs.max);
            self.CurFirePgs = Mathf.SmoothDamp(self.CurFirePgs, self.TarFirePgs, ref self.Speed, 0.5f);
            pgs.value = self.CurFirePgs;
            //ˢ»
            if (self.CurFirePgs <= 1)
            {
                self.CurFireCondition = 0;
                self.FUICuisineWindow.m_FireCondition.text = "Ϩ";
            }
            else if (self.CurFirePgs <= 40)
            {
                self.CurFireCondition = 1;
                self.FUICuisineWindow.m_FireCondition.text = "С";
            }
            else if(self.CurFirePgs <= 75)
            {
                self.CurFireCondition = 2;
                self.FUICuisineWindow.m_FireCondition.text = "л";
            }
            else
            {
                self.CurFireCondition = 3;
                self.FUICuisineWindow.m_FireCondition.text = "";
            }
            self.UpdateFireCondition();
        }

        private static void UpdateFireCondition(this FUICuisineWindowComponent self)
        {
            if (self.CurFireRequire != self.CurFireCondition)
            {
                self.mistakeTimeSum += 0.005f;
                if (self.mistakeTimeSum >= 1f)
                {
                    self.mistakeTimeSum -= 1f;
                    self.FireConditionMistakeCur += 30;
                    Log.Warning("ʧ");
                    if (self.FireConditionMistakeCur >= self.FireConditionMistakeMax)
                    {
                        CommonHelper.ShowHint(self.ZoneScene(), 1020);
                        self.EndCookingGame();
                    }
                    else
                    {
                        CommonHelper.ShowHint(self.ZoneScene(), 1024);
                    }
                }
            }
        }

        public static async void EndCookingGame(this FUICuisineWindowComponent self, int IsSucceed = 0)
        {
            TimerComponent.Instance.Remove(ref self.UpdateFireTimer);
            TimerComponent.Instance.Remove(ref self.UpdateCookingTimer);
            self.FUICuisineWindow.m_IsGaming.selectedIndex = 0;
            self.CurFireRequire = 0;
            self.mistakeTimeSum = 0;
            self.fireTimeSum = 0;
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            await CuisineHelper.EndCuisine(unit, IsSucceed, self.selectedCuisine);
        }

        //ˢ¼ʱ
        public static void UpdateCookingProgress(this FUICuisineWindowComponent self)
        {
            var pgs = self.FUICuisineWindow.m_CookingPgs.FGComp;
            self.gamePgs = Math.Clamp(self.gamePgs + 1, 0, (int)pgs.max);
            pgs.value = self.gamePgs;
            if(self.gamePgs == (int)pgs.max)
            {
                self.EndCookingGame(1);
                return;
            }
            self.CurFireRequire = self.AllFireRequire[self.gamePgs];
        }

        //ʾ
        private static void OpenMaterialInfo(this FUICuisineWindowComponent self, EventContext context)
        {
            GButton button = context.sender as GButton;
            int materialIndex = (int)button.data;
            int materialId = self.foodSelectedList[materialIndex];
            if(materialId == 0) return;
            var itemConfig = AllItemConfigCategory.Instance.Get(materialId);
            var materialConfig = MaterialConfigCategory.Instance.Get(itemConfig.RelatedId);
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var storeComp = unit.GetComponent<StoreComponent>();
            var popUpCom = self.FUICuisineWindow.m_MaterialDetailPopup;
            popUpCom.m_Name.text = itemConfig.Name;
            popUpCom.m_Description.text = itemConfig.Description;
            popUpCom.m_Price.SetVar("value", itemConfig.SellPrice.ToString()).FlushVars();
            popUpCom.m_OwnedNum.SetVar("value", storeComp.GetItemNum(itemConfig.Id).ToString()).FlushVars();
            popUpCom.m_MaterialType.text = ((ItemType)itemConfig.RelatedTable).ToString();
            popUpCom.m_Source.SetVar("value", itemConfig.GetMethod).FlushVars();
            popUpCom.m_status1.SetVar("value", materialConfig.FoodNum.ToString()).FlushVars();
            popUpCom.FGComp.visible = true;

            GRoot.inst.ShowPopup(self.FUICuisineWindow.m_MaterialDetailPopup.FGComp, button);
        }
    }      
}