﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using YooAsset;

namespace ET
{
    using FUILogin;
    using FUIServer;
    public class FUILoginComponentAwakeSystem : AwakeSystem<FUILoginComponent>
    {
        public override void Awake(FUILoginComponent self)
        {
            self.Awake();
        }
    }

    public class FUILoginComponentDestroySystem : DestroySystem<FUILoginComponent>
    {
        public override void Destroy(FUILoginComponent self)
        {
            self.Destroy();
        }
    }

    public static partial class FUILoginComponentSystem
    {
        public static void Awake(this FUILoginComponent self)
        {
            self.FUILogin = self.Parent.GetComponent<FUI_Login>();
            self.FUILogin.m_LoginButton.FGComp.AddClickListenerAsync(self.OnClickLogin);
            
            // add version msg
            self.FUILogin.m_Version.text = $"version:{YooAssetWrapper.GetResourceVersion()}";

#if CLIENTTEST
            // for test
            self.FUILogin.m_AccountName.text = "star123";
            self.FUILogin.m_Password.text = "star123";
            self.OnClickLogin().Coroutine();
#endif
        }

        public static async ETTask OnClickLogin(this FUILoginComponent self)
        {
            int errorCode = await LoginHelper.Login(self.ZoneScene(), ConstValue.LoginAddress, self.FUILogin.m_AccountName.text, self.FUILogin.m_Password.text);

            if (errorCode != ErrorCode.ERR_Success)
            {
                Log.Error(errorCode.ToString());
                return;
            }

            var zoneScene = self.ZoneScene();
            zoneScene.GetComponent<FUIComponent>().RemoveUI(FUI_Login.UIResName);
            var serverComp = await zoneScene.GetComponent<FUIComponent>().ShowUIAsync<FUI_Server, FUIServerComponent>(FUI_Server.UIPackageName);
            await serverComp.Init();
        }

        public static void Destroy(this FUILoginComponent self)
        {
            self.FUILogin.m_LoginButton.FGComp.onClick.Clear();
        }
    }
}
