/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using FairyGUI;
using UnityEngine;

namespace ET
{
    using FUIPeople;
    
    public class FUIPartnerListWindowComponentAwakeSystem : AwakeSystem<FUIPartnerListWindowComponent>
    {
        public override void Awake(FUIPartnerListWindowComponent self)
        {
            self.Awake();
        }
    }
                
    [FriendClass(typeof(Unit))]
    [FriendClass(typeof(People))]
    public static partial class FUIPartnerListWindowComponentSystem
    {
        public static void Awake(this FUIPartnerListWindowComponent self)
        {
            self.FUIPartnerListWindow = self.Parent.GetComponent<FUI_PartnerListWindow>();
            var win = new FUIPartnerListWindow();
            win.OnWindowShow = self.OnWindowShow;
            self.Window = win;
            self.Window.contentPane = self.FUIPartnerListWindow.FGComp;
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.People_PartnerItem, typeof(PartnerItem));
        }
        
        public static void OnWindowShow(this FUIPartnerListWindowComponent self)
        {
            self.ShowInfo();
        }
        
        public static void RefreshSkeleton(this FUIPartnerListWindowComponent self)
        {
            var list = self.FUIPartnerListWindow.m_PeopleList.m_PeopleList;
            var count = list.numChildren;

            for (int i = 0; i < count; i++)
            {
                PartnerItem item = list.GetChildAt(i) as PartnerItem;
                GameObject go = PeopleSkeletonCache.GetSkeletonGO((long)item.data);
                go.transform.localScale = new Vector3(15, 15, 15);
                item.SetAvatar(go);
            }
        }

        public static void ShowInfo(this FUIPartnerListWindowComponent self)
        {
            // show people list
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();

            var list = self.FUIPartnerListWindow.m_PeopleList.m_PeopleList;
            
            list.RemoveChildrenToPool();
            foreach (var v in peopleComp.Children)
            {
                People people = (People)v.Value;
                if (people.Config.Type == (int)RoleType.NormalPeople)
                {
                    continue;
                }
                PartnerItem item = (PartnerItem) list.AddItemFromPool();
                item.SetName(people.Name);
                item.data = people.Id;
                item.onClick.Remove(self.OnPartnerItemClick);
                item.onClick.Add(self.OnPartnerItemClick);
                GameObject go = PeopleSkeletonCache.GetSkeletonGO(people.Id);
                go.transform.localScale = new Vector3(15, 15, 15);
                item.SetAvatar(go);
                
                var numeric = people.GetComponent<NumericComponent>();
                int age = numeric.GetAsInt(NumericType.Age);
                item.SetAge(age);
                item.SetStrength(people.Labor);
            }

            self.FUIPartnerListWindow.m_PeopleNum.text = peopleComp.Children.Count.ToString();
        }
        
        private static void OnPartnerItemClick(this FUIPartnerListWindowComponent self, EventContext context)
        {
            var obj = context.sender as GObject;
            long peopleId = (long) obj.data;
            var fuiComponent = self.ZoneScene().GetComponent<FUIComponent>();
            var peopleInfoWin = fuiComponent.ShowWindow<FUI_PartnerInfoWindow, FUIPartnerInfoWindowComponent>();
            peopleInfoWin.ShowPartnerInfo(peopleId);
        }
    } 
                
}