/** This is an automatically generated class by FairyGUI. Please do not modify it. **/

using System.Collections.Generic;
using FairyGUI;
namespace ET
{
    using FUIResource;
    
    public class FUISelectWorkerWindowComponentAwakeSystem : AwakeSystem<FUISelectWorkerWindowComponent>
    {
        public override void Awake(FUISelectWorkerWindowComponent self)
        {
            self.Awake();
        }
    }
                
    
    [FriendClass(typeof(People))]
    public static partial class FUISelectWorkerWindowComponentSystem
    {
        public static void Awake(this FUISelectWorkerWindowComponent self)
        {
            self.FUISelectWorkerWindow = self.Parent.GetComponent<FUI_SelectWorkerWindow>();      
            self.Window = new Window();
            self.Window.contentPane = self.FUISelectWorkerWindow.FGComp;
            
            self.FUISelectWorkerWindow.m_PeopleTab.onChanged.Add(self.OnPeopleTabChanged);
            self.FUISelectWorkerWindow.m_CloseButton.FGComp.onClick.Add(self.OnCloseButtonClick);
            self.FUISelectWorkerWindow.m_ConfirmButton.FGComp.onClick.Add(self.OnConfirmButtonClick);
            
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Resource_WorkingCheckBox, typeof(FUIResource.WorkingCheckBox));
            UIObjectFactory.SetPackageItemExtension(FUIPackage.Resource_PeopleItem, typeof(FUIResource.PeopleItem));
        }

        public static ETTask<List<long>> ShowAsync(this FUISelectWorkerWindowComponent self, int maxNeedNum)
        {
            self.MaxNeedNum = maxNeedNum;

            self.CurSelectedWorkers.Clear();
            self.SelectWorkerTask = ETTask<List<long>>.Create();
            
            self.SelectPeopleTab(self.CurPeopleTab);

            return self.SelectWorkerTask;
        }

        private static void SelectPeopleTab(this FUISelectWorkerWindowComponent self, PeopleTab tab)
        {
            self.CurPeopleTab = tab;
            // show people list
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(self.ZoneScene());
            var peopleComp = unit.GetComponent<PeopleComponent>();
            var list = self.FUISelectWorkerWindow.m_PeopleList;
            list.RemoveChildrenToPool();
            
            List<People> showList = new List<People>();
            foreach (var v in peopleComp.Children.Values)
            {
                People people = (People)v;

                if (self.CurPeopleTab == PeopleTab.Villagers)
                {
                    if (people.Config.Type != (int) RoleTypeEnum.VILLAGERS)
                    {
                        continue;
                    }
                } else if (self.CurPeopleTab == PeopleTab.Partner)
                {
                    if (people.Config.Type == (int) RoleTypeEnum.VILLAGERS)
                    {
                        continue;
                    }
                }
                
                showList.Add(people);
            }


            self.SortPeople(ref showList);
 
            foreach (People people in showList)
            {
                FUIResource.PeopleItem item = (FUIResource.PeopleItem) list.AddItemFromPool();
                item.SetName(people.Name);
                item.SetIcon(PeopleViewHelper.GetHeadIconUrlByGender(people.GetGender()));
                item.SetStrength(people.Labor);
                
                item.WorkingCheckBox.data = people.Id;
                item.WorkingCheckBox.onClick.Remove(self.OnPeopleItemCheckBoxClick);
                item.WorkingCheckBox.onClick.Add(self.OnPeopleItemCheckBoxClick);
                int behave = people.GetBehaveType();
                item.SetStateMsg(TextHelper.GetPeopleStateMsg(behave));

                if (behave != ConstBehaveType.BEHAVE_IDLE)
                {
                    item.WorkingCheckBox.isWorkingOthers.selectedIndex = 1;
                    item.WorkingCheckBox.selected = false;
                }
                else
                {
                    item.WorkingCheckBox.isWorkingOthers.selectedIndex = 0;
                    item.WorkingCheckBox.selected = false;
                }
            }
            
            self.UpdateSelectNum(0);
        }

        private static void SortPeople(this FUISelectWorkerWindowComponent self, ref List<People> peoples)
        {
            peoples.Sort((x, y) =>
            {
                if (x.Config.Type < y.Config.Type)
                {
                    return -1;
                }

                if (x.GetBehaveType() < y.GetBehaveType())
                {
                    return -1;
                }

                if (x.Labor > y.Labor)
                {
                    return -1;
                }

                return 0;
            });
        }

        private static void UpdateSelectNum(this FUISelectWorkerWindowComponent self, int num)
        {
            self.FUISelectWorkerWindow.m_SelectNum.text = $"{num}/{self.MaxNeedNum}";
        }

        private static void OnPeopleTabChanged(this FUISelectWorkerWindowComponent self)
        {
            int index = self.FUISelectWorkerWindow.m_PeopleTab.selectedIndex;
            self.SelectPeopleTab((PeopleTab)index);
        }
        
        private static void OnPeopleItemCheckBoxClick(this FUISelectWorkerWindowComponent self, EventContext context)
        {
            var sender = (GObject)context.sender;
            var peopleId = (long) sender.data;

            self.CurSelectedWorkers.Add(peopleId);
        }

        private static void OnCloseButtonClick(this FUISelectWorkerWindowComponent self)
        {
            self.SelectWorkerTask?.SetResult(new List<long>());
            self.SelectWorkerTask = null;
            self.Window.Hide();
        }

        private static void OnConfirmButtonClick(this FUISelectWorkerWindowComponent self)
        {
            self.SelectWorkerTask?.SetResult(self.CurSelectedWorkers);
            self.SelectWorkerTask = null;
            self.Window.Hide();
        }
    } 
                
}