﻿namespace ET.PeopleBehave
{
    [Behave(ConstBehaveType.BEHAVE_HARVEST)]
    public class Behave_Harvest : BehaveBase
    {
        public override void Handle(People people)
        {
            PlayPlantAnim(people).Coroutine();
        }
        
        public async ETTask PlayPlantAnim(People people)
        {
            var pAnimator = people.GetComponent<PeopleAnimatorComponent>();
            if (pAnimator == null)
            {
                return;
            }
            pAnimator.StopAll();
            pAnimator.PlayAnimation(PeopleAnimEnum.Gather);
            
            await TimerComponent.Instance.WaitAsync(3000);

            Unit unit = UnitHelper.GetMyUnitFromZoneScene(people.ZoneScene());
            var targetId = people.GetTargetId();
            var farmland = unit.GetGrandChild<Farmland>(targetId);
            if (farmland == null)
            {
                Log.Error($"Can't find farmland: ${targetId}");
                return;
            }
            FarmlandHelper.FarmlandHarvest(unit, farmland, people).Coroutine();
        }
    }
}