﻿namespace ET.PeopleBehave
{
    [Behave(ConstBehaveType.BEHAVE_PREPARE_CONSTRUCT)]
    [FriendClass(typeof(Construct))]
    public class Behave_Prepare_Construct : BehaveBase
    {
        public override void Handle(People people)
        {
            PeopleViewComponent pView = people.GetComponent<PeopleViewComponent>();
            if (pView == null)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(people.ZoneScene());

            long targetId = people.GetTargetId();
            ConstructComponent cc = unit.GetComponent<ConstructComponent>();
                    
            if (cc != null)
            {
                Construct c = cc.GetChild<Construct>(targetId);
                if (c != null)
                {
                    if (c.PreparePeopleIdList.Contains(people.Id))
                    {
                        var cView = c.GetComponent<ConstructViewComponent>();
                        pView.MoveToPos(cView.GetWorkerPos(people.Id));
                    }
                }
            }
            
            var pAnimator = people.GetComponent<PeopleAnimatorComponent>();
            if (pAnimator == null)
            {
                return;
            }
            pAnimator.StopAll();
            pAnimator.PlayAnimation(PeopleAnimEnum.Run);
        }
    }
}