﻿namespace ET.PeopleBehave
{
    [Behave(ConstBehaveType.BEHAVE_PREPARE_PLANT)]
    [FriendClass(typeof(Unit))]
    public class Behave_Prepare_Plant : BehaveBase
    {
        public override void Handle(People people)
        {
            PeopleViewComponent pView = people.GetComponent<PeopleViewComponent>();
            if (pView == null)
            {
                return;
            }
            
            Unit unit = UnitHelper.GetMyUnitFromZoneScene(people.ZoneScene());
            
            // 为farmland 
            long targetId = people.GetTargetId();

            var farmland = unit.GetGrandChild<Farmland>(targetId);

            if (farmland != null)
            {
                Building building = farmland.GetParent<Building>();

                if (building != null)
                {
                    var bView = building.GetComponent<BuildingViewComponent>();
                    pView.MoveToPos(bView.GetWorkPos());
                }
            }
            
            var pAnimator = people.GetComponent<PeopleAnimatorComponent>();
            if (pAnimator == null)
            {
                return;
            }
            pAnimator.StopAll();
            pAnimator.PlayAnimation(PeopleAnimEnum.Run);
        }
    }
}