﻿namespace ET
{
    public static class TextHelper
    {
        public static string Building_Place_Invalid = "建造位置被占用";
        public static string GetSeasonText(int season)
        {
            switch (season)
            {
                case 1:
                    return "春";
                case 2:
                    return "夏";
                case 3:
                    return "秋";
                case 4:
                    return "冬";
                default:
                    return "";
            }
        }

        public static string GetGrowUpTimeText(int day)
        {
            return $"[color=#00FF00]{day}[/color]日后成熟";
        }
        
        public static string GetPeopleStateMsg(int behaveType)
        {
            string msg = "未知";
            switch (behaveType)
            {
                case ConstBehaveType.BEHAVE_IDLE:
                    msg = "空闲";
                    break;
                case ConstBehaveType.BEHAVE_PREPARE_GATHER:
                    msg = "去采集的路上";
                    break;
                case ConstBehaveType.BEHAVE_GATHER:
                    msg = "正在采集";
                    break;
                case ConstBehaveType.BEHAVE_PREPARE_CONSTRUCT:
                    msg = "在去建造的路上";
                    break;
                case ConstBehaveType.BEHAVE_CONSTRUCT:
                    msg = "正在建造";
                    break;
                case ConstBehaveType.BEHAVE_PREPARE_PLANT:
                    msg = "去种植的路上";
                    break;
                case ConstBehaveType.BEHAVE_PLANT:
                    msg = "种植中";
                    break;
                case ConstBehaveType.BEHAVE_PREPARE_HARVEST:
                    msg = "去收获的路上";
                    break;
                case ConstBehaveType.BEHAVE_HARVEST:
                    msg = "收获中";
                    break;
                case ConstBehaveType.BEHAVE_PREPARE_CABIN:
                    msg = "去田间小屋的路上";
                    break;
                case ConstBehaveType.BEHAVE_CABIN:
                    msg = "田间小屋";
                    break;
                default:
                    Log.Error($"Unknown behaviour type:{behaveType}");
                    break;
            }

            return msg;
        }
    }
}