﻿using System;
using System.Collections.Generic;
using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Bson.Serialization.Options;
using MongoDB.Bson;

namespace ET
{
    public class People: Entity, IAwake<int>, ISerializeToEntity
    {
        public string Name;
        public int ConfigId;
        public int Labor; //劳力值，受年龄段限制
        public int LaborExp; //劳力经验
        public int Physique; //体质
        public int PhysiqueExp; //体质经验
        public int Exp;
        public int Level;
        public int Age;
        public int BehaveType;
        public long TargetId;
        public int CurrSkillId;
        [BsonRepresentation(BsonType.Double, AllowTruncation = true)]
        public float PosX;
        [BsonRepresentation(BsonType.Double, AllowTruncation = true)]
        public float PosY;
        public int Disease; //疾病值
        public int PeopleType; //主角，伙伴，村民
        public int Gender; //性别
        public int AgeMax; //寿命上限
        public int AgeExp;
        public int Wisdom; //智慧
        public int MoveSpeed; //移动速度
        public int Injury; //外伤

        [BsonIgnore]
        public RoleConfig Config => RoleConfigCategory.Instance.Get(this.ConfigId);

        [BsonIgnore]
        public AttributesGroupConfig AttriConfig
        {
            get
            {
                if (this.Config.AttributesGroup > 0)
                {
                    return AttributesGroupConfigCategory.Instance.Get(this.Config.AttributesGroup);
                }

                return null;
            }
            set
            {
                this.AttriConfig = value;
            }
        }
    }
}