﻿using MongoDB.Bson.Serialization.Attributes;

namespace ET
{
    public enum SynthesisState
    {
        Working = 1,
        Stop = 2,
        Finished = 3,
    }

    public class Synthesis: Entity, IAwake, ISerializeToEntity
    {
        public int ConfigId = 0; //配置id
        public long CurrAmount = 0; //已经制作数量
        public long MaxAmount = 0; //总共需要制作数量
        public long UpdateTime = 0; //时间
        public int Progress = 0; //进度条
        public int State = 0; //状态  1：正在制作，2：停止制作, 3:结束制作

        [BsonIgnore]
        public SynthesisConfig Config => SynthesisConfigCategory.Instance.Get(this.ConfigId);
    }
}