﻿using System.Collections.Generic;
using MongoDB.Bson.Serialization.Attributes;

namespace ET
{
    public struct WeatherInfo
    {
        public int ConfigId;
        public int Cd;
        public int StartDay; //game day
    }
    public class Weather:Entity,IAwake,ISerializeToEntity
    {
        public int ConfigId;
        public int Times; //当前季节触发次数
        public List<int> SpringList;  //春天列表
        public List<int> SummerList;
        public List<int> AutumnList;
        public List<int> WinterList;
        public int StartTime;//开始时间(游戏时间)
        public int Duration; //持续
        public int State;   //1表示天气影响中
        public Dictionary<int, WeatherInfo> WeatherHistory = new Dictionary<int, WeatherInfo>();

        [BsonIgnore]
        public WeatherConfig Config => WeatherConfigCategory.Instance.Get(this.ConfigId);




    }
}