namespace ET
{
    public static partial class ErrorCode
    {
        public const int ERR_Success = 0;

        // 1-11004 是SocketError请看SocketError定义
        //-----------------------------------
        // 100000-109999是Core层的错误

        // 110000以下的错误请看ErrorCore.cs

        // 这里配置逻辑层的错误码
        // 110000 - 200000是抛异常的错误
       
        // 200001以上不抛异常

        public const int ERR_NetWorkError = 200002;     // 网络异常
        public const int ERR_LoginInfoError = 200003;   // 登入错误
        public const int ERR_RequestRepeadtedly = 200004;   // 重复请求
        public const int ERR_TokenError = 200005;

        public const int ERR_RoleNameIsNull = 200006;
        public const int ERR_RoleNameConflict = 200007;
        public const int ERR_RoleNotExist = 200008;
        public const int ERR_RequestSceneTypeError = 200009;
        public const int ERR_ConnectGateKeyError = 200010;
        public const int ERR_OtherAccountLogin = 200011;
        public const int ERR_SessionPlayerError = 200012;
        public const int ERR_NonePlayerError = 200013;
        public const int ERR_SessionStateError = 200014;
        public const int ERR_EnterGameError = 200015;
        public const int ERR_ReEnterGameError = 200016;
        
        public const int ERR_BuildError = 210001;
        public const int ERR_ResponseError = 210002;   //返回异常

        public const int ERR_ResourceNotFound = 210003; //找不到资源

        public const int ERR_ResourceGatherError = 210004;//采集失败

        public const int ERR_GatherNotFound = 210005; //找不到采集实体
        public const int ERR_StartGatherFail= 210006; //开始采集失败

        public const int ERR_GetStoreFail = 210007;

        public const int ERR_StopGatherFail = 210008;// 停止采集失败

        public const int ERR_PeopleMoveFail = 210009; //people移动失败

        public const int ERR_CreateConstructFail = 210010;//启动建造失败

        public const int ERR_MaterialNotEnough = 210011; //材料不足

        public const int ERR_ConstructNotFound = 210012; //找不到建造实体

        public const int ERR_OperateFail = 210013; //操作失败

        public const int ERR_PeopleNotFound = 210014;//没有找到people

        public const int ERR_ResourceOver = 210015; //资源已经采完了

        public const int ERR_BehaveError = 210016;// 行为错误

        public const int ERR_StopConstructError = 210017;//停止建造错误

        public const int ERR_PeopleTypeError = 210018; //

        public const int ERR_ConfigError = 210019;//读取不到配置表
        public const int ERR_SynthesisError = 210020;//制作失败
        public const int ERR_NotProductionBuilding = 210021;//找不到生产建筑
        public const int ERR_SynthesisNotFound = 210022;//找不到制作
        
        public const int ERR_CuisineError = 210023;//烹饪研发失败
        public const int ERR_MenuError = 210024;// 获取菜单失败
        public const int ERR_UseError = 210025;// 使用失败
        public const int ERR_DropError = 210026;// 丢弃失败

        public const int ERR_RootOutResourceError = 210027;//铲除错误
        public const int ERR_AddResourceError = 210028;//添加资源错误

        public const int ERR_NOT_FOUND_BUILD = 210029;//找不到目标建筑
        //210100-210199战斗用
        public const int ERR_CanNotFoundEnemy = 210101; //找不到对手
        public const int ERR_CanNotFoundBattle = 210102; //找不到对手
        public const int ERR_SkillNotCd = 210103; //技能还没CD
        public const int ERR_SkillSpiritNoEnongh = 210104; //战意不够
        public const int ERR_FighterSilence = 210105;//玩家被沉默了
        public const int ERR_FighterConstraint = 210106; //玩家被禁锢了
        public const int ERR_SkillNotFound = 210107; //没有该技能
        //210201-210322 种植相关
        public const int ERR_FarmlandNotFree = 210201; //农场不是空闲
        public const int ERR_PlantNotRipe = 210202;   //农作物没有成熟
        public const int ERR_FarmlandNotFound = 210203;// 农场没有找到
        public const int ERR_CropConfigNotFound = 210204;// 农场没有找到
        public const int ERR_SeedNotEnough = 210205;// 农场没有找到
        public const int ERR_FarmlandNotRipe = 210206;//没有成熟
        public const int ERR_FarmlandNotSeed = 210207;//没有播种
        public const int ERR_CabinNotFound = 210208;//没有找到小屋
        public const int ERR_ArriveCabinFail = 210209;//到达小屋失败
        public const int ERR_CabinNotPeople = 210210;//小屋没有常驻人
    }
}