﻿using System.Collections.Generic;
using UnityEngine;

namespace ET
{
    [ComponentOf(typeof(Construct))]
    public class ConstructViewComponent : Entity, IAwake, IDestroy
    {
        public GameObject BuildingRoot;
        public SpriteRenderer ProgressSR;
        public Construct Construct;
        public long UpdateTimer;
        public List<Vector3> WorkingPoints = new List<Vector3>();
        public Dictionary<long, int> WorkingPosDict = new Dictionary<long, int>();

        public readonly int FillAmount = Shader.PropertyToID("_FillAmount");
        public readonly int UVRect = Shader.PropertyToID("_UVRect");
    }
}