﻿using FairyGUI;

namespace ET
{
    public class PrepareWorkerItem : GComponent
    {
        private GLoader _Icon;
        public GButton AddWorkerButton;
        public GButton CancelButton;
        public Controller _hasPeopleCtrl;
        
        public override void ConstructFromXML(FairyGUI.Utils.XML cxml)
        {
            base.ConstructFromXML(cxml);
            
            this._Icon = this.GetChild("Icon").asLoader;
            this.AddWorkerButton = this.GetChild("AddWorkerButton").asButton;
            this.CancelButton = this.GetChild("CancelButton").asButton;
            this._hasPeopleCtrl = this.GetController("hasPeople");
        }
        
        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }

        public void SetHasPeople(bool hasPeople)
        {
            this._hasPeopleCtrl.selectedIndex = hasPeople? 1 : 0;
        }

        public bool HasPeople()
        {
            return this._hasPeopleCtrl.selectedIndex != 0;
        }
    }
}