﻿using FairyGUI;
using FairyGUI.Utils;

namespace ET
{
    public class CuisineTreeItem1 : GButton
    {
        private GTextField m_Name;
        private GTextField m_NutritionValue;
        private GTextField m_MasteryValue;
        private GTextField m_WaterCost;
        private GLoader m_Icon;

        public override void ConstructFromXML(XML xml)
        {
            base.ConstructFromXML(xml);

            this.m_Name = this.GetChild("Name").asTextField;
            this.m_Icon = this.GetChild("Icon").asLoader;
            this.m_NutritionValue = this.GetChild("NutritionValue").asTextField;
            this.m_MasteryValue = this.GetChild("MasteryValue").asTextField;
            this.m_WaterCost = this.GetChild("WaterCost").asTextField;
        }

        public void SetName(string name)
        {
            this.m_Name.text = name;
        }

        public void SetIcon(string value)
        {
            this.m_Icon.url = $"ui://AllItem/{value}";
        }

        public void SetNutrition(int value)
        {
            this.m_NutritionValue.SetVar("value", value.ToString()).FlushVars();
        }

        public void SetMastery(int value)
        {
            this.m_MasteryValue.SetVar("value", value.ToString()).FlushVars();
        }

        public void SetWaterCost(int value)
        {
            this.m_WaterCost.SetVar("value", value.ToString()).FlushVars();
        }
    }
}
