﻿using FairyGUI;

namespace ET
{
    public class SkillGroupItem : GButton
    {
        private GLoader _Icon;
        private GTextField _Name;
        private GTextField _Desc;

        public override void ConstructFromXML(FairyGUI.Utils.XML cxml)
        {
            base.ConstructFromXML(cxml);
            
            this._Icon = this.GetChild("Icon").asLoader;
            this._Name = this.GetChild("Name").asTextField;
            this._Desc = this.GetChild("Desc").asTextField;
        }
        
        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }

        public void SetName(string name)
        {
            this._Name.text = name;
        }

        public void SetDesc(string desc)
        {
            this._Desc.text = desc;
        }
    }
}