﻿using FairyGUI;

namespace ET
{
    public class StoreItem : GButton
    {
        private GLoader _Icon;
        private GTextField _Name;
        private GTextField _Amount;
        
        public override void ConstructFromXML(FairyGUI.Utils.XML cxml)
        {
            base.ConstructFromXML(cxml);

            this._Icon = this.GetChild("Icon").asLoader;
            this._Name = this.GetChild("Name").asTextField;
            this._Amount = this.GetChild("Amount").asTextField;
        }

        public void SetIcon(string url)
        {
            this._Icon.url = url;
        }

        public void SetName(string name)
        {
            this._Name.text = name;
        }

        public void SetAmount(long value)
        {
            this._Amount.text = value.ToString();
        }
    }
}