﻿using FairyGUI;
using FairyGUI.Utils;

namespace ET
{
    public class MaterialInfoItem : GButton
    {
        private GLoader m_lcon;
        private GTextField m_Amount;

        public override void ConstructFromXML(XML xml)
        {
            base.ConstructFromXML(xml);

            this.m_lcon = this.GetChild("Icon").asLoader;
            this.m_Amount = this.GetChild("Amount").asTextField;
        }

        public void SetIcon(string url)
        {
            this.m_lcon.url = $"ui://AllItem/{url}";
        }

        public void SetAmount(long owned, int require)
        {
            string ownedColor = owned < require ? $"[color=#FF0000]{owned}[/color]" : $"[color=#000000]{owned}[/color]";
            this.m_Amount.SetVar("owned", ownedColor).SetVar("require", require.ToString()).FlushVars();
        }
    }
}
